#pragma once

typedef void * (* _Runtime_DynamicCast)(void * srcObj, UInt32 arg1, const void * fromType, const void * toType, UInt32 arg4);
extern const _Runtime_DynamicCast Runtime_DynamicCast;

#define DYNAMIC_CAST(obj, from, to) ( ## to *) Runtime_DynamicCast((void*)(obj), 0, RTTI_ ## from, RTTI_ ## to, 0)

extern const void * RTTI_BaseFormComponent;
extern const void * RTTI_IFormFactory;
extern const void * RTTI_AlchemyItem;
extern const void * RTTI_BGSDualCastData;
extern const void * RTTI_Setting;
extern const void * RTTI_GameSettingCollection;
extern const void * RTTI_TESFullName;
extern const void * RTTI_EffectSetting;
extern const void * RTTI_EnchantmentItem;
extern const void * RTTI_IngredientItem;
extern const void * RTTI_MagicItemTraversalFunctor;
extern const void * RTTI_MagicItemFindKeywordFunctor;
extern const void * RTTI_FindEqualsFunctor;
extern const void * RTTI_GetCostliestEffectFunctor;
extern const void * RTTI_LongestDurationFunctor;
extern const void * RTTI_LargestAreaFunctor;
extern const void * RTTI_MagicItem;
extern const void * RTTI_ScrollItem;
extern const void * RTTI_SpellItem;
extern const void * RTTI_BSExtraData;
extern const void * RTTI_ExtraEditorID;
extern const void * RTTI_ExtraSeenData;
extern const void * RTTI_ExtraHavok;
extern const void * RTTI_MagicTarget;
extern const void * RTTI_ExtraPrimitive;
extern const void * RTTI_ExtraMagicLight;
extern const void * RTTI_ExtraLock;
extern const void * RTTI_ExtraFromAlias;
extern const void * RTTI_ExtraTeleport;
extern const void * RTTI_ExtraTeleportName;
extern const void * RTTI_ExtraOwnership;
extern const void * RTTI_ExtraGlobal;
extern const void * RTTI_ExtraRank;
extern const void * RTTI_ExtraCount;
extern const void * RTTI_ExtraWorn;
extern const void * RTTI_ExtraWornLeft;
extern const void * RTTI_ExtraCannotWear;
extern const void * RTTI_ExtraHealth;
extern const void * RTTI_ExtraHealthPerc;
extern const void * RTTI_ExtraTimeLeft;
extern const void * RTTI_ExtraCharge;
extern const void * RTTI_ExtraScale;
extern const void * RTTI_ExtraCachedScale;
extern const void * RTTI_ExtraHotkey;
extern const void * RTTI_ExtraLocation;
extern const void * RTTI_ExtraTresPassPackage;
extern const void * RTTI_ExtraLeveledItem;
extern const void * RTTI_ExtraOutfitItem;
extern const void * RTTI_ExtraRagDollData;
extern const void * RTTI_ExtraEncounterZone;
extern const void * RTTI_ExtraRandomTeleportMarker;
extern const void * RTTI_ExtraLocationRefType;
extern const void * RTTI_ExtraLeveledItemBase;
extern const void * RTTI_ExtraLevCreaModifier;
extern const void * RTTI_ExtraPoison;
extern const void * RTTI_ExtraEnchantment;
extern const void * RTTI_ExtraLastFinishedSequence;
extern const void * RTTI_ExtraEmittanceSource;
extern const void * RTTI_ExtraMultiBoundRef;
extern const void * RTTI_ExtraSavedHavokData;
extern const void * RTTI_ExtraRefractionProperty;
extern const void * RTTI_ExtraStartingWorldOrCell;
extern const void * RTTI_ExtraHasNoRumors;
extern const void * RTTI_ExtraSound;
extern const void * RTTI_ExtraCreatureAwakeSound;
extern const void * RTTI_ExtraWeaponIdleSound;
extern const void * RTTI_ExtraWeaponAttackSound;
extern const void * RTTI_ExtraActivateLoopSound;
extern const void * RTTI_ExtraCanTalkToPlayer;
extern const void * RTTI_ExtraObjectHealth;
extern const void * RTTI_ExtraTerminalState;
extern const void * RTTI_ExtraNavMeshPortal;
extern const void * RTTI_ExtraModelSwap;
extern const void * RTTI_ExtraRadius;
extern const void * RTTI_ExtraAmmo;
extern const void * RTTI_ExtraCombatStyle;
extern const void * RTTI_ExtraPatrolRefData;
extern const void * RTTI_ExtraOcclusionPlaneRefData;
extern const void * RTTI_ExtraPortalRefData;
extern const void * RTTI_ExtraRoomRefData;
extern const void * RTTI_ExtraPackageData;
extern const void * RTTI_ExtraCollisionData;
extern const void * RTTI_ExtraIgnoredBySandbox;
extern const void * RTTI_ExtraLightData;
extern const void * RTTI_ExtraSceneData;
extern const void * RTTI_ExtraBadPosition;
extern const void * RTTI_ExtraHeadTrackingWeight;
extern const void * RTTI_ExtraFavorCost;
extern const void * RTTI_ExtraTextDisplayData;
extern const void * RTTI_ExtraAlphaCutoff;
extern const void * RTTI_ExtraUniqueID;
extern const void * RTTI_ExtraFlags;
extern const void * RTTI_ExtraRefrPath;
extern const void * RTTI_ExtraDecalGroup;
extern const void * RTTI_ExtraCellWaterEnvMap;
extern const void * RTTI_ExtraRegionList;
extern const void * RTTI_ExtraCellMusicType;
extern const void * RTTI_ExtraCellAcousticSpace;
extern const void * RTTI_ExtraCellSkyRegion;
extern const void * RTTI_ExtraCellImageSpace;
extern const void * RTTI_ExtraCellWaterType;
extern const void * RTTI_ExtraNorthRotation;
extern const void * RTTI_ExtraDetachTime;
extern const void * RTTI_ExtraGIDBuffer;
extern const void * RTTI_ExtraStartingPosition;
extern const void * RTTI_ExtraOriginalReference;
extern const void * RTTI_ExtraPackageStartLocation;
extern const void * RTTI_ExtraReferenceHandle;
extern const void * RTTI_ExtraSpawnContainer;
extern const void * RTTI_ExtraMultiBound;
extern const void * RTTI_ExtraRoom;
extern const void * RTTI_ExtraSavedAnimation;
extern const void * RTTI_ExtraHeadingTarget;
extern const void * RTTI_ExtraActorCause;
extern const void * RTTI_ExtraHorse;
extern const void * RTTI_ExtraForcedTarget;
extern const void * RTTI_ExtraForcedLandingMarker;
extern const void * RTTI_ExtraWaterData;
extern const void * RTTI_ExtraCell3D;
extern const void * RTTI_NonActorMagicTarget;
extern const void * RTTI_ExtraMissingLinkedRefIDs;
extern const void * RTTI_ExtraOpenCloseActivateRef;
extern const void * RTTI_ExtraEnableStateParent;
extern const void * RTTI_ExtraAttachRef;
extern const void * RTTI_ExtraAshPileRef;
extern const void * RTTI_ExtraItemDropper;
extern const void * RTTI_ExtraMissingRefIDs;
extern const void * RTTI_ExtraFollower;
extern const void * RTTI_ExtraEnableStateChildren;
extern const void * RTTI_ExtraAttachRefChildren;
extern const void * RTTI_ExtraActivateRef;
extern const void * RTTI_ExtraActivateRefChildren;
extern const void * RTTI_ExtraReflectedRefs;
extern const void * RTTI_ExtraReflectorRefs;
extern const void * RTTI_ExtraWaterLightRefs;
extern const void * RTTI_ExtraLitWaterRefs;
extern const void * RTTI_ExtraDroppedItemList;
extern const void * RTTI_ExtraFriendHits;
extern const void * RTTI_ExtraFactionChanges;
extern const void * RTTI_ExtraGuardedRefData;
extern const void * RTTI_ExtraAliasInstanceArray;
extern const void * RTTI_ExtraPromotedRef;
extern const void * RTTI_ExtraLargeRefOwnerCells;
extern const void * RTTI_ExtraScriptedAnimDependence;
extern const void * RTTI_ExtraLinkedRef;
extern const void * RTTI_ExtraLinkedRefChildren;
extern const void * RTTI_ExtraAttachedArrows3D;
extern const void * RTTI_ExtraWaterCurrentZoneData;
extern const void * RTTI_ExtraLight;
extern const void * RTTI_ExtraLeveledCreature;
extern const void * RTTI_ExtraMapMarker;
extern const void * RTTI_ExtraAction;
extern const void * RTTI_ExtraContainerChanges;
extern const void * RTTI_ExtraLockList;
extern const void * RTTI_ExtraSoul;
extern const void * RTTI_ExtraGhost;
extern const void * RTTI_ExtraShouldWear;
extern const void * RTTI_ExtraInfoGeneralTopic;
extern const void * RTTI_ExtraPackage;
extern const void * RTTI_ExtraPlayerCrimeList;
extern const void * RTTI_ExtraPersistentCell;
extern const void * RTTI_ExtraRunOncePacks;
extern const void * RTTI_ExtraDistantData;
extern const void * RTTI_ExtraOcclusionShape;
extern const void * RTTI_ExtraPortal;
extern const void * RTTI_ExtraEditorRefMoveData;
extern const void * RTTI_ExtraSayTopicInfoOnceADay;
extern const void * RTTI_ExtraSayToTopicInfo;
extern const void * RTTI_ExtraPatrolRefInUseData;
extern const void * RTTI_ExtraFollowerSwimBreadcrumbs;
extern const void * RTTI_ExtraAnimNoteReceiver;
extern const void * RTTI_ExtraGroupConstraint;
extern const void * RTTI_ExtraRaceData;
extern const void * RTTI_ExtraAnimGraphManager;
extern const void * RTTI_ExtraInteraction;
extern const void * RTTI_ExtraDismemberedLimbs;
extern const void * RTTI_ExtraCellGrassData;
extern const void * RTTI_MultiBoundMarkerData;
extern const void * RTTI_InterfacedClass;
extern const void * RTTI_BSTask;
extern const void * RTTI_BSStream;
extern const void * RTTI_IOTask;
extern const void * RTTI_QueuedTempEffect;
extern const void * RTTI_BackgroundProcessThread;
extern const void * RTTI_AttachDistant3DTask;
extern const void * RTTI_QueuedReference;
extern const void * RTTI_INISettingCollection;
extern const void * RTTI_QueuedHead;
extern const void * RTTI_QueuedHelmet;
extern const void * RTTI_QueuedTree;
extern const void * RTTI_QueuedCharacter;
extern const void * RTTI_QueuedAnimationObject;
extern const void * RTTI_QueuedPlayer;
extern const void * RTTI_AddCellGrassTask;
extern const void * RTTI_BSTempNodeManager;
extern const void * RTTI_ICellAttachDetachEventSource;
extern const void * RTTI_TES;
extern const void * RTTI_INIPrefSettingCollection;
extern const void * RTTI_BGSStoryManagerTreeForm;
extern const void * RTTI_BGSStoryManagerNodeBase;
extern const void * RTTI_BGSLoadFormBuffer;
extern const void * RTTI_BGSStoryManagerBranchNode;
extern const void * RTTI_BGSAttackDataForm;
extern const void * RTTI_BGSBipedObjectForm;
extern const void * RTTI_BGSBlockBashData;
extern const void * RTTI_BGSDestructibleObjectForm;
extern const void * RTTI_BGSEquipType;
extern const void * RTTI_BGSIdleCollection;
extern const void * RTTI_BGSKeywordForm;
extern const void * RTTI_BGSMenuDisplayObject;
extern const void * RTTI_BGSMessageIcon;
extern const void * RTTI_BGSOverridePackCollection;
extern const void * RTTI_BGSPerkRankArray;
extern const void * RTTI_BGSPickupPutdownSounds;
extern const void * RTTI_BGSSkinForm;
extern const void * RTTI_TESActorBaseData;
extern const void * RTTI_TESAIForm;
extern const void * RTTI_TESAttackDamageForm;
extern const void * RTTI_TESModelRDT;
extern const void * RTTI_TESBipedModelForm;
extern const void * RTTI_TESContainer;
extern const void * RTTI_TESDescription;
extern const void * RTTI_TESEnchantableForm;
extern const void * RTTI_BSStorage;
extern const void * RTTI_BSMemStorage;
extern const void * RTTI_BSVMLoadTask;
extern const void * RTTI_TESForm;
extern const void * RTTI_TESIcon;
extern const void * RTTI_TESImageSpaceModifiableForm;
extern const void * RTTI_TESLeveledList;
extern const void * RTTI_TESModel;
extern const void * RTTI_TESModelTextureSwap;
extern const void * RTTI_TESProduceForm;
extern const void * RTTI_TESQualityForm;
extern const void * RTTI_TESRaceForm;
extern const void * RTTI_TESReactionForm;
extern const void * RTTI_TESSpellList;
extern const void * RTTI_TESTexture;
extern const void * RTTI_TESValueForm;
extern const void * RTTI_TESWeightForm;
extern const void * RTTI_ActionInput;
extern const void * RTTI_BGSAnimSoundStateManager;
extern const void * RTTI_BGSParticleArrayAttach;
extern const void * RTTI_BGSHavokGeometryAttach;
extern const void * RTTI_BGSNamedNodeAttach;
extern const void * RTTI_BGSMultiTechniqueAttach;
extern const void * RTTI_hkpRayHitCollector;
extern const void * RTTI_hkpAllRayHitTempCollector;
extern const void * RTTI_BGSDecalNode;
extern const void * RTTI_QueuedPromoteReferencesTask;
extern const void * RTTI_NiAlphaProperty;
extern const void * RTTI_BGSQueuedGrassModelHandles;
extern const void * RTTI_NiRefObject;
extern const void * RTTI_BSMultiBoundSphere;
extern const void * RTTI_BGSPrimitive;
extern const void * RTTI_BGSPrimitivePlane;
extern const void * RTTI_BGSPrimitiveBox;
extern const void * RTTI_BGSPrimitiveSphere;
extern const void * RTTI_BSMultiBoundAABB;
extern const void * RTTI_BSMultiBoundOBB;
extern const void * RTTI_BSPortal;
extern const void * RTTI_BGSPrimitiveLine;
extern const void * RTTI_BSAnimationGraphChannel;
extern const void * RTTI_BSAnimGroupSequence;
extern const void * RTTI_IBSAnimNoteReceiver;
extern const void * RTTI_BSAnimNoteReceiver;
extern const void * RTTI_GridArray;
extern const void * RTTI_GridCellArray;
extern const void * RTTI_BGSActionData;
extern const void * RTTI_TESActionData;
extern const void * RTTI_TESCameraState;
extern const void * RTTI_LocalMapCamera;
extern const void * RTTI_BSSplatterExtraData;
extern const void * RTTI_TESRegion;
extern const void * RTTI_TESRegionData;
extern const void * RTTI_TESRegionDataGrass;
extern const void * RTTI_TESRegionDataLandscape;
extern const void * RTTI_TESRegionDataManager;
extern const void * RTTI_TESRegionDataMap;
extern const void * RTTI_TESRegionDataSound;
extern const void * RTTI_TESRegionDataWeather;
extern const void * RTTI_TESRegionObjectBase;
extern const void * RTTI_TESRegionGrassObject;
extern const void * RTTI_TESRegionGrassObjectList;
extern const void * RTTI_TESRegionList;
extern const void * RTTI_BGSAddonNodeSoundHandleExtra;
extern const void * RTTI_BGSAddonNode;
extern const void * RTTI_BGSApparatus;
extern const void * RTTI_BGSArtObject;
extern const void * RTTI_BGSArtObjectCloneTask;
extern const void * RTTI_BGSConstructibleObject;
extern const void * RTTI_BGSPreloadable;
extern const void * RTTI_BGSDebris;
extern const void * RTTI_BGSExplosion;
extern const void * RTTI_BGSHazard;
extern const void * RTTI_BGSMovableStatic;
extern const void * RTTI_BGSOutfit;
extern const void * RTTI_BGSProjectile;
extern const void * RTTI_BGSStaticCollection;
extern const void * RTTI_BGSTalkingActivator;
extern const void * RTTI_TESAmmo;
extern const void * RTTI_TESCombatStyle;
extern const void * RTTI_TESEffectShader;
extern const void * RTTI_TESFlora;
extern const void * RTTI_TESFurniture;
extern const void * RTTI_TESGrass;
extern const void * RTTI_TESKey;
extern const void * RTTI_TESLevCharacter;
extern const void * RTTI_TESLevItem;
extern const void * RTTI_TESLevSpell;
extern const void * RTTI_TESObjectLIGH;
extern const void * RTTI_TESObject;
extern const void * RTTI_TESBoundObject;
extern const void * RTTI_TESBoundAnimObject;
extern const void * RTTI_BGSOpenCloseForm;
extern const void * RTTI_TESObjectACTI;
extern const void * RTTI_TESObjectANIO;
extern const void * RTTI_TESObjectARMA;
extern const void * RTTI_TESObjectARMO;
extern const void * RTTI_TESObjectBOOK;
extern const void * RTTI_TESObjectCONT;
extern const void * RTTI_IFadeDoneCallback;
extern const void * RTTI_TESObjectDOOR;
extern const void * RTTI_TESObjectMISC;
extern const void * RTTI_TESObjectSTAT;
extern const void * RTTI_TESObjectTREE;
extern const void * RTTI_TESObjectWEAP;
extern const void * RTTI_TESSoulGem;
extern const void * RTTI_BGSEncounterZone;
extern const void * RTTI_QueuedPromoteLargeReferencesTask;
extern const void * RTTI_BGSLightingTemplate;
extern const void * RTTI_BGSLocation;
extern const void * RTTI_QueuedPromoteLocationReferencesTask;
extern const void * RTTI_BGSLocationRefType;
extern const void * RTTI_BGSReferenceEffect;
extern const void * RTTI_BSParticleShaderEmitter;
extern const void * RTTI_BSParticleShaderCubeEmitter;
extern const void * RTTI_BSParticleShaderRainEmitter;
extern const void * RTTI_BSParticleShaderSnowEmitter;
extern const void * RTTI_NiAdditionalGeometryData;
extern const void * RTTI_BGSShaderParticleGeometryData;
extern const void * RTTI_ExteriorCellLoaderTask;
extern const void * RTTI_ImageSpaceModifierInstance;
extern const void * RTTI_ImageSpaceModifierInstanceForm;
extern const void * RTTI_ImageSpaceModifierInstanceDOF;
extern const void * RTTI_ImageSpaceModifierInstanceRB;
extern const void * RTTI_TESClimate;
extern const void * RTTI_TESImageSpace;
extern const void * RTTI_NiFloatData;
extern const void * RTTI_NiColorData;
extern const void * RTTI_TESImageSpaceModifier;
extern const void * RTTI_BSPackedAdditionalGeometryData;
extern const void * RTTI_TESChildCell;
extern const void * RTTI_hkBaseObject;
extern const void * RTTI_hkReferencedObject;
extern const void * RTTI_hkpMoppCode;
extern const void * RTTI_TESObjectLAND;
extern const void * RTTI_TESLandTexture;
extern const void * RTTI_hkpEntityListener;
extern const void * RTTI_ExtraProcessMiddleLow;
extern const void * RTTI_hkpWorldCinfo;
extern const void * RTTI_CheckWithinMultiBoundTask;
extern const void * RTTI_TESObjectCELL;
extern const void * RTTI_TESWindListener;
extern const void * RTTI_bhkCollisionObject;
extern const void * RTTI_bhkPCollisionObject;
extern const void * RTTI_bhkSerializable;
extern const void * RTTI_bhkShape;
extern const void * RTTI_bhkWorldObject;
extern const void * RTTI_bhkEntity;
extern const void * RTTI_bhkPhantom;
extern const void * RTTI_bhkAabbPhantom;
extern const void * RTTI_ReferenceEffectController;
extern const void * RTTI_bhkSphereRepShape;
extern const void * RTTI_bhkConvexShape;
extern const void * RTTI_bhkShapePhantom;
extern const void * RTTI_bhkSimpleShapePhantom;
extern const void * RTTI_hkpShape;
extern const void * RTTI_BSHandleRefObject;
extern const void * RTTI_hkpPhantomCallbackShape;
extern const void * RTTI_bhkAcousticSpacePhantomCallbackShape;
extern const void * RTTI_OwnedController;
extern const void * RTTI_OwnedCameraEffectController;
extern const void * RTTI_bhkBoxShape;
extern const void * RTTI_bhkSphereShape;
extern const void * RTTI_bhkRigidBody;
extern const void * RTTI_TESObjectREFR;
extern const void * RTTI_IAnimationStreamRead;
extern const void * RTTI_IAnimationStreamWrite;
extern const void * RTTI_AnimationStreamLoadGame;
extern const void * RTTI_AnimationStreamSaveGame;
extern const void * RTTI_ExtraUsedMarkers;
extern const void * RTTI_ExtraReservedMarkers;
extern const void * RTTI_WaterMaterialData;
extern const void * RTTI_TESWaterForm;
extern const void * RTTI_TESTexture1024;
extern const void * RTTI_TESWeather;
extern const void * RTTI_TESWorldSpace;
extern const void * RTTI_BGSAcousticSpace;
extern const void * RTTI_BGSCameraPath;
extern const void * RTTI_NiFormArray;
extern const void * RTTI_BGSCameraShot;
extern const void * RTTI_BGSCollisionLayer;
extern const void * RTTI_BGSColorForm;
extern const void * RTTI_BGSDefaultObjectManager;
extern const void * RTTI_BGSFootstep;
extern const void * RTTI_BGSFootstepSet;
extern const void * RTTI_BGSImpactData;
extern const void * RTTI_BGSImpactDataSet;
extern const void * RTTI_BGSListForm;
extern const void * RTTI_BSMaterialObject;
extern const void * RTTI_BGSMaterialObject;
extern const void * RTTI_BGSMaterialType;
extern const void * RTTI_BGSMenuIcon;
extern const void * RTTI_BGSMessage;
extern const void * RTTI_BGSMusicPaletteTrack;
extern const void * RTTI_BGSMusicSilenceTrack;
extern const void * RTTI_BGSMusicSingleTrack;
extern const void * RTTI_BSIMusicTrack;
extern const void * RTTI_BGSMusicTrack;
extern const void * RTTI_BGSMusicTrackFormWrapper;
extern const void * RTTI_BSIMusicType;
extern const void * RTTI_BGSMusicType;
extern const void * RTTI_BSIReverbType;
extern const void * RTTI_BGSReverbParameters;
extern const void * RTTI_BSISoundCategory;
extern const void * RTTI_BGSSoundCategory;
extern const void * RTTI_BSISoundDescriptor;
extern const void * RTTI_BGSSoundDescriptorForm;
extern const void * RTTI_BSISoundOutputModel;
extern const void * RTTI_BGSSoundOutput;
extern const void * RTTI_BGSStandardSoundDef;
extern const void * RTTI_BSTextureSet;
extern const void * RTTI_BSShaderTextureSet;
extern const void * RTTI_BGSTextureSet;
extern const void * RTTI_IVisitProcedures;
extern const void * RTTI_TESGlobal;
extern const void * RTTI_TESLoadScreen;
extern const void * RTTI_Script;
extern const void * RTTI_MobIterOperator;
extern const void * RTTI_TESShout;
extern const void * RTTI_TESSound;
extern const void * RTTI_TESWordOfPower;
extern const void * RTTI_BGSAction;
extern const void * RTTI_BGSAssociationType;
extern const void * RTTI_TESModelPSA;
extern const void * RTTI_BGSBodyPartData;
extern const void * RTTI_BGSDialogueBranch;
extern const void * RTTI_BGSEntryPointFunctionData;
extern const void * RTTI_BGSEntryPointFunctionDataTwoValue;
extern const void * RTTI_BGSEntryPointFunctionDataLeveledList;
extern const void * RTTI_BGSEntryPointFunctionDataSpellItem;
extern const void * RTTI_BGSEntryPointFunctionDataText;
extern const void * RTTI_BGSEntryPointFunctionDataActivateChoice;
extern const void * RTTI_BGSEntryPointFunctionDataOneValue;
extern const void * RTTI_BGSEntryPointFunctionDataBooleanGraphVariable;
extern const void * RTTI_BGSEquipSlot;
extern const void * RTTI_TESModelTri;
extern const void * RTTI_BGSHeadPart;
extern const void * RTTI_BGSIdleMarker;
extern const void * RTTI_BGSKeyword;
extern const void * RTTI_BGSBaseAlias;
extern const void * RTTI_BGSLocAlias;
extern const void * RTTI_BGSMovementType;
extern const void * RTTI_BGSNote;
extern const void * RTTI_BGSPerkEntry;
extern const void * RTTI_BGSQuestPerkEntry;
extern const void * RTTI_BGSAbilityPerkEntry;
extern const void * RTTI_BGSEntryPointPerkEntry;
extern const void * RTTI_BGSPerk;
extern const void * RTTI_BGSRagdoll;
extern const void * RTTI_BGSRefAlias;
extern const void * RTTI_BGSRelationship;
extern const void * RTTI_BGSScene;
extern const void * RTTI_BGSSceneAction;
extern const void * RTTI_BGSSceneActionDialogue;
extern const void * RTTI_BGSSceneActionPackage;
extern const void * RTTI_BGSSceneActionTimer;
extern const void * RTTI_BGSVoiceType;
extern const void * RTTI_Reset3DMobIterator;
extern const void * RTTI_TESClass;
extern const void * RTTI_TESEyes;
extern const void * RTTI_TESFaction;
extern const void * RTTI_TESIdleForm;
extern const void * RTTI_ActorValueOwner;
extern const void * RTTI_BSFaceGenModelExtraData;
extern const void * RTTI_TESActorBase;
extern const void * RTTI_TESNPC;
extern const void * RTTI_QueuedPromoteQuestTask;
extern const void * RTTI_TESQuest;
extern const void * RTTI_BGSTextureModel;
extern const void * RTTI_BGSBehaviorGraphModel;
extern const void * RTTI_AttackAnimationArrayMap;
extern const void * RTTI_TESRace;
extern const void * RTTI_TESTopic;
extern const void * RTTI_TESTopicInfo;
extern const void * RTTI_BGSAcousticSpaceListener;
extern const void * RTTI_BGSZoneTargetListener;
extern const void * RTTI_ZoneEntry;
extern const void * RTTI_TargetEntry;
extern const void * RTTI_TrapTargetEntry;
extern const void * RTTI_bhkCartTether;
extern const void * RTTI_bhkConstraint;
extern const void * RTTI_bhkPrismaticConstraint;
extern const void * RTTI_bhkAction;
extern const void * RTTI_bhkUnaryAction;
extern const void * RTTI_BSTaskletData;
extern const void * RTTI_BSTasklet;
extern const void * RTTI_BSWin32TaskletData;
extern const void * RTTI_bhkBvTreeShape;
extern const void * RTTI_bhkTriSampledHeightFieldBvTreeShape;
extern const void * RTTI_CellMopp;
extern const void * RTTI_hkpContactListener;
extern const void * RTTI_bhkBackfaceContactListener;
extern const void * RTTI_FOCollisionListener;
extern const void * RTTI_hkpIslandActivationListener;
extern const void * RTTI_FOIslandActivationListener;
extern const void * RTTI_hkNativeFileSystem;
extern const void * RTTI_HavokStreambufFactory;
extern const void * RTTI_HavokFileStreambufWriter;
extern const void * RTTI_HavokError;
extern const void * RTTI_hkpCdPointCollector;
extern const void * RTTI_hkpAllCdPointCollector;
extern const void * RTTI_LoadedAreaBound;
extern const void * RTTI_RagdollFurnitureListener;
extern const void * RTTI_hkpClosestRayHitCollector;
extern const void * RTTI_SpecificItemCollector;
extern const void * RTTI_hkpCdBodyPairCollector;
extern const void * RTTI_hkpPhantomListener;
extern const void * RTTI_TriggerEntry;
extern const void * RTTI_hkpAllCdBodyPairTempCollector;
extern const void * RTTI_bhkTrapListener;
extern const void * RTTI_TESTrapListener;
extern const void * RTTI_TrapEntry;
extern const void * RTTI_hkpAllCdPointTempCollector;
extern const void * RTTI_Atmosphere;
extern const void * RTTI_Clouds;
extern const void * RTTI_Moon;
extern const void * RTTI_Precipitation;
extern const void * RTTI_SkyEffectController;
extern const void * RTTI_TempLoadGameBuffer;
extern const void * RTTI_SkyStaticFindFunctor;
extern const void * RTTI_Sky;
extern const void * RTTI_SkyObject;
extern const void * RTTI_Stars;
extern const void * RTTI_NiBillboardNode;
extern const void * RTTI_Sun;
extern const void * RTTI_BShkNonTransformController;
extern const void * RTTI_BGShkPhonemeController;
extern const void * RTTI_BSFaceGenAnimationData;
extern const void * RTTI_FutBinaryFileC;
extern const void * RTTI_BSResourceFaceGenBinaryFile;
extern const void * RTTI_BSFaceGenKeyframe;
extern const void * RTTI_BSFaceGenKeyframeMultiple;
extern const void * RTTI_BSFaceGenModel;
extern const void * RTTI_BSFaceGenMorphDataHair;
extern const void * RTTI_BSFaceGenBaseMorphExtraData;
extern const void * RTTI_BSFaceGenMorphDataHead;
extern const void * RTTI_BSFaceGenNiNode;
extern const void * RTTI_BSFadeNodeCuller;
extern const void * RTTI_ActorValueInfo;
extern const void * RTTI_BGSSkillPerkTreeNode;
extern const void * RTTI_IAIWorldLocation;
extern const void * RTTI_BGSAIWorldLocationRefRadius;
extern const void * RTTI_BGSAIWorldLocationPointRadius;
extern const void * RTTI_BGSAIWorldLocationInteriorCell;
extern const void * RTTI_BGSAttackData;
extern const void * RTTI_BGSAttackDataMap;
extern const void * RTTI_IPackageData;
extern const void * RTTI_IAIWorldLocationHandle;
extern const void * RTTI_BGSPackageDataLocationWrapper;
extern const void * RTTI_BGSPackageDataBool;
extern const void * RTTI_BGSPackageDataLocation;
extern const void * RTTI_BGSPackageDataTargetSelector;
extern const void * RTTI_BGSPackageDataRefOLD;
extern const void * RTTI_BGSPackageDataFloat;
extern const void * RTTI_BGSPackageDataInt;
extern const void * RTTI_ObjectListItem;
extern const void * RTTI_BGSPackageDataObjectList;
extern const void * RTTI_BGSPackageDataRef;
extern const void * RTTI_BGSPackageDataTopic;
extern const void * RTTI_IProcedureTreeItem;
extern const void * RTTI_BGSProcedureTreeConditionalItem;
extern const void * RTTI_IProcedureTreeExecState;
extern const void * RTTI_BGSProcedureTreeOneChildExecState;
extern const void * RTTI_BGSProcedureDialogueExecState;
extern const void * RTTI_BGSProcedureDoneExecState;
extern const void * RTTI_BGSProcedureEatExecState;
extern const void * RTTI_BGSProcedureFindExecState;
extern const void * RTTI_BGSProcedureGuardExecState;
extern const void * RTTI_BGSProcedureHoldPositionExecState;
extern const void * RTTI_BGSProcedureKeepAnEyeOnExecState;
extern const void * RTTI_BGSProcedureSayExecState;
extern const void * RTTI_BGSProcedureWaitExecState;
extern const void * RTTI_BGSProcedureTreeBranch;
extern const void * RTTI_BGSProcedureTreeSimultaneousExecState;
extern const void * RTTI_BGSProcedureTreeSimultaneous;
extern const void * RTTI_BGSProcedureTreeRandom;
extern const void * RTTI_BGSProcedureTreeSequence;
extern const void * RTTI_BGSProcedureTreeStacked;
extern const void * RTTI_BGSProcedureTreeSequenceExecState;
extern const void * RTTI_BGSProcedureTreeStackedExecState;
extern const void * RTTI_BGSProcedureTreeRandomExecState;
extern const void * RTTI_IProcedure;
extern const void * RTTI_BGSProcedureBase;
extern const void * RTTI_BGSProcedureDone;
extern const void * RTTI_IPackageDataTypeCheck;
extern const void * RTTI_BGSProcedureAcquire;
extern const void * RTTI_BGSProcedureAcquireExecState;
extern const void * RTTI_BGSProcedureActivateExecState;
extern const void * RTTI_BGSProcedureActivate;
extern const void * RTTI_BGSProcedureDialogue;
extern const void * RTTI_BGSProcedureDialogueActivateExecState;
extern const void * RTTI_BGSProcedureDialogueActivate;
extern const void * RTTI_BGSProcedureEat;
extern const void * RTTI_BGSProcedureEscortExecState;
extern const void * RTTI_BGSProcedureEscort;
extern const void * RTTI_BGSProcedureFind;
extern const void * RTTI_BGSProcedureFleeExecState;
extern const void * RTTI_BGSProcedureFlee;
extern const void * RTTI_BGSProcedureFlightGrabExecState;
extern const void * RTTI_BGSProcedureFlightGrab;
extern const void * RTTI_IMovementParameters;
extern const void * RTTI_MovementParameters;
extern const void * RTTI_BGSProcedureFollowExecState;
extern const void * RTTI_BGSProcedureFollow;
extern const void * RTTI_BGSProcedureFollowTo;
extern const void * RTTI_BGSProcedureForceGreet;
extern const void * RTTI_BGSProcedureGuard;
extern const void * RTTI_BGSProcedureHoldPosition;
extern const void * RTTI_BGSProcedureHoverExecState;
extern const void * RTTI_BGSProcedureHover;
extern const void * RTTI_BGSProcedureKeepAnEyeOn;
extern const void * RTTI_BGSProcedureLockUnlockExecState;
extern const void * RTTI_BGSProcedureLock;
extern const void * RTTI_BGSProcedureUnlock;
extern const void * RTTI_BGSProcedureOrbitExecState;
extern const void * RTTI_BGSProcedureOrbit;
extern const void * RTTI_BGSProcedurePatrol;
extern const void * RTTI_BGSProcedurePatrolExecState;
extern const void * RTTI_BGSProcedurePursue;
extern const void * RTTI_BGSProcedureSandbox;
extern const void * RTTI_BGSProcedureSandboxExecState;
extern const void * RTTI_BGSProcedureSay;
extern const void * RTTI_BGSProcedureShout;
extern const void * RTTI_BGSProcedureShoutExecState;
extern const void * RTTI_BGSProcedureSitSleepExecState;
extern const void * RTTI_BGSProcedureSit;
extern const void * RTTI_BGSProcedureSleep;
extern const void * RTTI_BGSProcedureTravelExecState;
extern const void * RTTI_BGSProcedureTravel;
extern const void * RTTI_BGSProcedureTreeProcedure;
extern const void * RTTI_BGSProcedureUseIdleMarkerExecState;
extern const void * RTTI_BGSProcedureUseIdleMarker;
extern const void * RTTI_BGSProcedureUseMagic;
extern const void * RTTI_BGSProcedureUseMagicExecState;
extern const void * RTTI_BGSProcedureUseWeaponExecState;
extern const void * RTTI_BGSProcedureUseWeapon;
extern const void * RTTI_BGSProcedureWait;
extern const void * RTTI_BGSProcedureWanderExecState;
extern const void * RTTI_BGSProcedureWander;
extern const void * RTTI_BGSVisitProceduresCheckGuardWarnTarget;
extern const void * RTTI_BGSVisitProceduresInitActorLocation;
extern const void * RTTI_PackageCreator;
extern const void * RTTI_TESPackage;
extern const void * RTTI_DialoguePackage;
extern const void * RTTI_TESPackageData;
extern const void * RTTI_TESAmbushPackageData;
extern const void * RTTI_TESCustomPackageData;
extern const void * RTTI_TESDialoguePackageData;
extern const void * RTTI_TESEatPackageData;
extern const void * RTTI_TESEscortPackageData;
extern const void * RTTI_TESFollowPackageData;
extern const void * RTTI_TESPatrolPackageData;
extern const void * RTTI_TESUseItemPackageData;
extern const void * RTTI_ActorPackageData;
extern const void * RTTI_TESUseWeaponPackageData;
extern const void * RTTI_UseWeaponActorPackageData;
extern const void * RTTI_PackageLocation;
extern const void * RTTI_ITempEffectFactory;
extern const void * RTTI_BSTempEffect;
extern const void * RTTI_BSTempEffectDebris;
extern const void * RTTI_NiSkinInstance;
extern const void * RTTI_BSDismemberSkinInstance;
extern const void * RTTI_BSTempEffectGeometryDecal;
extern const void * RTTI_BSTempEffectParticle;
extern const void * RTTI_BGSParticleObjectCloneTask;
extern const void * RTTI_BSLightingShaderMaterial;
extern const void * RTTI_BSTempEffectSimpleDecal;
extern const void * RTTI_BSTempEffectSPG;
extern const void * RTTI_BSTempEffectWeaponBlood;
extern const void * RTTI_BSTerrainEffect;
extern const void * RTTI_NavMesh;
extern const void * RTTI_BSPathingStreamRead;
extern const void * RTTI_PathingStreamMasterFileRead;
extern const void * RTTI_NavMeshInfoMap;
extern const void * RTTI_hkpEntityActivationListener;
extern const void * RTTI_bhkObstacleDeactivationListener;
extern const void * RTTI_bhkObstacleRemovalListener;
extern const void * RTTI_BSNavmeshReferenceObstacleArray;
extern const void * RTTI_NavMeshObstacleManager;
extern const void * RTTI_ObstacleTaskData;
extern const void * RTTI_PathingCoverLocation;
extern const void * RTTI_BSPathingCellManager;
extern const void * RTTI_Pathing;
extern const void * RTTI_BSPathingCell;
extern const void * RTTI_PathingCell;
extern const void * RTTI_BSPathingDoor;
extern const void * RTTI_PathingDoor;
extern const void * RTTI_BSPathingLockData;
extern const void * RTTI_PathingLockData;
extern const void * RTTI_PathingRequest;
extern const void * RTTI_BSPathingSpace;
extern const void * RTTI_PathingSpace;
extern const void * RTTI_TeleportDoorSearch;
extern const void * RTTI_NavMeshSearchClosePoint;
extern const void * RTTI_NavMeshSearchFitSphere;
extern const void * RTTI_NavMeshSearchFlee;
extern const void * RTTI_NavMeshSearchHide;
extern const void * RTTI_NavMeshSearchLOS;
extern const void * RTTI_NavMeshSearchMaxCost;
extern const void * RTTI_NavMeshSearchSLPoint;
extern const void * RTTI_PathingRequestClosePoint;
extern const void * RTTI_IPathBuilderFactoryBase;
extern const void * RTTI_PathingRequestClosestGoal;
extern const void * RTTI_PathingRequestCover;
extern const void * RTTI_PathingRequestFlee;
extern const void * RTTI_PathingRequestFly;
extern const void * RTTI_PathingRequestFlyAction;
extern const void * RTTI_PathingRequestFlyHover;
extern const void * RTTI_PathingRequestFlyLand;
extern const void * RTTI_PathingRequestFlyOrbit;
extern const void * RTTI_PathingRequestFlyTakeOff;
extern const void * RTTI_PathingRequestHide;
extern const void * RTTI_PathingRequestLOS;
extern const void * RTTI_PathingRequestOptimalLocation;
extern const void * RTTI_PathingRequestRotate;
extern const void * RTTI_PathingRequestSafeStraightLine;
extern const void * RTTI_PathingRequestStopMoving;
extern const void * RTTI_BGSQueuedTerrainUpdate;
extern const void * RTTI_BGSQueuedTerrainInitialLoad;
extern const void * RTTI_BGSQueuedTerrainDowngrade;
extern const void * RTTI_BGSQueuedTerrainUpgrade;
extern const void * RTTI_BGSQueuedObjectInitialLoad;
extern const void * RTTI_BGSQueuedObjectDowngrade;
extern const void * RTTI_BGSQueuedObjectUpgrade;
extern const void * RTTI_ImageSpaceEffectParam;
extern const void * RTTI_WaterReflectionData;
extern const void * RTTI_WaterDisplacementData;
extern const void * RTTI_WaterNormalsData;
extern const void * RTTI_TESWaterDisplacement;
extern const void * RTTI_TESWaterObject;
extern const void * RTTI_TESWaterNormals;
extern const void * RTTI_TESWaterReflections;
extern const void * RTTI_BGSStoryManagerTreeVisitor;
extern const void * RTTI_BGSStoryManagerQuestFinder;
extern const void * RTTI_BGSStoryManager;
extern const void * RTTI_BGSStoryManagerEventNode;
extern const void * RTTI_BGSStoryManagerQuestNode;
extern const void * RTTI_BGSStoryTeller;
extern const void * RTTI_AnimationClipDataSingleton;
extern const void * RTTI_BSIFootIkRaycastInterfaceDB;
extern const void * RTTI_hkaRaycastInterface;
extern const void * RTTI_CachedRaycastData;
extern const void * RTTI_BGSFootIkRaycastInterfaceDB;
extern const void * RTTI_IGamebryoSequenceGeneratorHolderSingleton;
extern const void * RTTI_BGSGamebryoSequenceGeneratorHolderSingleton;
extern const void * RTTI_BGSSynchronizedAnimationInstance;
extern const void * RTTI_BSLimbIKModifierUtilityCastInfo;
extern const void * RTTI_BSLimbIKModifierUtility;
extern const void * RTTI_IAnimationGraphManagerHolder;
extern const void * RTTI_IAnimationGraphManagerLoadingTask;
extern const void * RTTI_SimpleAnimationGraphManagerLoadingTask;
extern const void * RTTI_SimpleAnimationGraphManagerHolder;
extern const void * RTTI_WeaponAnimationGraphManagerHolder;
extern const void * RTTI_TailAnimationGraphManagerHolder;
extern const void * RTTI_TESCamera;
extern const void * RTTI_AbsorbEffect;
extern const void * RTTI_AccumulatingValueModifierEffect;
extern const void * RTTI_FindMaxMagnitudeVisitor;
extern const void * RTTI_FinishActiveEffectVisitor;
extern const void * RTTI_ActiveEffectReferenceEffectController;
extern const void * RTTI_ActiveEffect;
extern const void * RTTI_ActorMagicCaster;
extern const void * RTTI_MagicItemDataCollector;
extern const void * RTTI_BoundItemEffect;
extern const void * RTTI_CloakEffect;
extern const void * RTTI_CommandEffect;
extern const void * RTTI_CommandSummonedEffect;
extern const void * RTTI_CureEffect;
extern const void * RTTI_DarknessEffect;
extern const void * RTTI_DetectLifeEffect;
extern const void * RTTI_DisarmEffect;
extern const void * RTTI_DisguiseEffect;
extern const void * RTTI_DispelEffect;
extern const void * RTTI_DualValueModifierEffect;
extern const void * RTTI_EtherealizationEffect;
extern const void * RTTI_GrabActorEffect;
extern const void * RTTI_GuideEffect;
extern const void * RTTI_InvisibilityEffect;
extern const void * RTTI_LightEffect;
extern const void * RTTI_LockEffect;
extern const void * RTTI_ActorTargetCheck;
extern const void * RTTI_MagicCaster;
extern const void * RTTI_KeywordDispelFunctor;
extern const void * RTTI_IsSpellTargetFunctor;
extern const void * RTTI_IsSpellTypeTargetFunctor;
extern const void * RTTI_FindEffectKeywordOnTargetFunctor;
extern const void * RTTI_ModelReferenceEffect;
extern const void * RTTI_NightEyeEffect;
extern const void * RTTI_NonActorMagicCaster;
extern const void * RTTI_OpenEffect;
extern const void * RTTI_ParalysisEffect;
extern const void * RTTI_PeakValueModifierEffect;
extern const void * RTTI_ReanimateEffect;
extern const void * RTTI_ReferenceEffect;
extern const void * RTTI_WeaponEnchantmentController;
extern const void * RTTI_ScriptEffect;
extern const void * RTTI_ScriptedRefEffect;
extern const void * RTTI_BSParticleShaderRayEmitter;
extern const void * RTTI_BSParticleShaderCollisionEmitter;
extern const void * RTTI_ShaderReferenceEffect;
extern const void * RTTI_BSParticleShaderGeometryEmitter;
extern const void * RTTI_SlowTimeEffect;
extern const void * RTTI_SoulTrapEffect;
extern const void * RTTI_StaggerEffect;
extern const void * RTTI_SummonCreatureEffect;
extern const void * RTTI_SummonPlacementEffect;
extern const void * RTTI_RallyEffect;
extern const void * RTTI_DemoralizeEffect;
extern const void * RTTI_TurnUndeadEffect;
extern const void * RTTI_BanishEffect;
extern const void * RTTI_CalmEffect;
extern const void * RTTI_FrenzyEffect;
extern const void * RTTI_TelekinesisEffect;
extern const void * RTTI_ValueAndConditionsEffect;
extern const void * RTTI_ValueModifierEffect;
extern const void * RTTI_VampireLordEffect;
extern const void * RTTI_WerewolfEffect;
extern const void * RTTI_WerewolfFeedEffect;
extern const void * RTTI_BGSPlayerMusicChanger;
extern const void * RTTI_MenuTopicManager;
extern const void * RTTI_BGSSaveLoadStatsMap;
extern const void * RTTI_BGSLoadGameBuffer;
extern const void * RTTI_BGSSaveFormBuffer;
extern const void * RTTI_BGSSaveGameBuffer;
extern const void * RTTI_SaveStorageWrapper;
extern const void * RTTI_LoadStorageWrapper;
extern const void * RTTI_BGSMoviePlayer;
extern const void * RTTI_IExplosionFactory;
extern const void * RTTI_ChainExplosion;
extern const void * RTTI_EnhanceWeaponEffect;
extern const void * RTTI_GarbageCollector;
extern const void * RTTI_InitTESThread;
extern const void * RTTI_MovementAvoidBoxEventAdapter;
extern const void * RTTI_PathManagerPositionPlayerAdapter;
extern const void * RTTI_CharacterCollisionMessagePlayerAdapter;
extern const void * RTTI_PlayerSleepWaitMovementControllerAdapter;
extern const void * RTTI_DoorObstacleAdapter;
extern const void * RTTI_UISaveLoadManager;
extern const void * RTTI_MagicFavorites;
extern const void * RTTI_BSGeometryListCullingProcess;
extern const void * RTTI_RegSettingCollection;
extern const void * RTTI_bhkTelekinesisListener;
extern const void * RTTI_BGSImpactManager;
extern const void * RTTI_Main;
extern const void * RTTI_IMemoryManagerFile;
extern const void * RTTI_MemoryManagerFile;
extern const void * RTTI_IMemoryManagerFileFactory;
extern const void * RTTI_SceneGraph;
extern const void * RTTI_SeenData;
extern const void * RTTI_IntSeenData;
extern const void * RTTI_SpawnHazardEffect;
extern const void * RTTI_IUIMessageData;
extern const void * RTTI_BSUIMessageData;
extern const void * RTTI_hkpWorldPostSimulationListener;
extern const void * RTTI_IPostAnimationChannelUpdateFunctor;
extern const void * RTTI_IAnimationSetCallbackFunctor;
extern const void * RTTI_ProcessCallbackAdapter;
extern const void * RTTI_SaveLoadMagicCasterVisitor;
extern const void * RTTI_SaveGameMagicCasterVisitor;
extern const void * RTTI_LoadGameMagicCasterVisitor;
extern const void * RTTI_RevertSelectedSpellFunctor;
extern const void * RTTI_Actor;
extern const void * RTTI_HoldWardSpellsActiveEffectVisitor;
extern const void * RTTI_hkpAllCdBodyPairCollector;
extern const void * RTTI_bhkFilteredCdBodyCollector;
extern const void * RTTI_HasSpellVisitor;
extern const void * RTTI_SumHostileEffectsFunctor;
extern const void * RTTI_ActorMediator;
extern const void * RTTI_ActorState;
extern const void * RTTI_BSLinearTaskThread;
extern const void * RTTI_AILinearTaskThread;
extern const void * RTTI_BGSVisitProceduresInitActorAnimPose;
extern const void * RTTI_BGSVisitProceduresProcess;
extern const void * RTTI_RunActionAnimationLoadedCallback;
extern const void * RTTI_InstantInteractionCallback;
extern const void * RTTI_WeaponAnimationLoadedCallback;
extern const void * RTTI_BSPlayerDistanceCheckController;
extern const void * RTTI_BSSimpleScaleController;
extern const void * RTTI_Character;
extern const void * RTTI_HighActorCuller;
extern const void * RTTI_MountInteraction;
extern const void * RTTI_bhkMouseSpringAction;
extern const void * RTTI_hkpFirstCdBodyPairCollector;
extern const void * RTTI_IMessageBoxCallback;
extern const void * RTTI_PlayerCharacter;
extern const void * RTTI_PlayerRegionState;
extern const void * RTTI_IMovementFormIDManager;
extern const void * RTTI_ProcessListMovementInterface;
extern const void * RTTI_SyncQueueObj;
extern const void * RTTI_RefrInteraction;
extern const void * RTTI_ActorMover;
extern const void * RTTI_MovementParametersFixed;
extern const void * RTTI_bhkCharacterCollisionHandler;
extern const void * RTTI_CharacterCollisionHandler;
extern const void * RTTI_IMovementAvoidanceManager;
extern const void * RTTI_MovementAvoidanceManager;
extern const void * RTTI_IMovementMessageInterface;
extern const void * RTTI_IMovementDirectControl;
extern const void * RTTI_IMovementPlannerDirectControl;
extern const void * RTTI_IMovementSelectIdle;
extern const void * RTTI_IMovementMotionDrivenControl;
extern const void * RTTI_MovementControllerNPC;
extern const void * RTTI_BSPathingStreamWrite;
extern const void * RTTI_BSPathingStreamSimpleBufferWrite;
extern const void * RTTI_MovementHandlerAgentDirectControl;
extern const void * RTTI_MovementHandlerAgentPlayerControls;
extern const void * RTTI_MovementHandlerAgentPlayerControlsActionTrigger;
extern const void * RTTI_IMovementSetSprinting;
extern const void * RTTI_MovementHandlerAgentSprintActionTrigger;
extern const void * RTTI_MovementHandlerAgentStairsHelper;
extern const void * RTTI_MovementMessageActorCollision;
extern const void * RTTI_MovementMessage;
extern const void * RTTI_MovementMessageMovementTypeChange;
extern const void * RTTI_MovementPlannerAgentDirectControl;
extern const void * RTTI_MovementPlannerAgentHorseControls;
extern const void * RTTI_MovementPlannerAgentKeepOffset;
extern const void * RTTI_MovementPlannerAgentWarp;
extern const void * RTTI_MovementTweenerAgentAnimationDriven;
extern const void * RTTI_ITweenerNodeFollowerSetup;
extern const void * RTTI_MovementTweenerAgentNodeFollower;
extern const void * RTTI_PathingStreamLoadGame;
extern const void * RTTI_PathingStreamSaveGame;
extern const void * RTTI_PlayerInputHandler;
extern const void * RTTI_InputEvent;
extern const void * RTTI_ButtonEvent;
extern const void * RTTI_PlayerControls;
extern const void * RTTI_IStaticAvoidNodeManager;
extern const void * RTTI_StaticAvoidNodeManager;
extern const void * RTTI_AlarmPackage;
extern const void * RTTI_CustomActorPackageData;
extern const void * RTTI_EscortActorPackageData;
extern const void * RTTI_FleePackage;
extern const void * RTTI_GuardActorPackageData;
extern const void * RTTI_PatrolActorPackageData;
extern const void * RTTI_SandBoxActorPackageData;
extern const void * RTTI_SpectatorPackage;
extern const void * RTTI_TrespassPackage;
extern const void * RTTI_ActorKnowledge;
extern const void * RTTI_DetectionCollector;
extern const void * RTTI_DetectionState;
extern const void * RTTI_WeaponRightSwingHandler;
extern const void * RTTI_WeaponLeftSwingHandler;
extern const void * RTTI_AttackWinStartHandler;
extern const void * RTTI_AttackWinEndHandler;
extern const void * RTTI_AttackStopHandler;
extern const void * RTTI_RecoilStopHandler;
extern const void * RTTI_LeftHandSpellFireHandler;
extern const void * RTTI_RightHandSpellFireHandler;
extern const void * RTTI_VoiceSpellFireHandler;
extern const void * RTTI_LeftHandSpellCastHandler;
extern const void * RTTI_RightHandSpellCastHandler;
extern const void * RTTI_VoiceSpellCastHandler;
extern const void * RTTI_WeaponBeginDrawRightHandler;
extern const void * RTTI_WeaponBeginSheatheRightHandler;
extern const void * RTTI_CameraOverrideStartHandler;
extern const void * RTTI_CameraOverrideStopHandler;
extern const void * RTTI_RightHandWeaponDrawHandler;
extern const void * RTTI_RightHandWeaponSheatheHandler;
extern const void * RTTI_HitFrameHandler;
extern const void * RTTI_AnticipateAttackHandler;
extern const void * RTTI_StaggeredStopHandler;
extern const void * RTTI_ChairEnterHandler;
extern const void * RTTI_BedEnterHandler;
extern const void * RTTI_ChairFurnitureExitHandler;
extern const void * RTTI_BedFurnitureExitHandler;
extern const void * RTTI_PlayerChairEnterHandler;
extern const void * RTTI_PlayerBedEnterHandler;
extern const void * RTTI_PlayerFurnitureExitHandler;
extern const void * RTTI_KillActorHandler;
extern const void * RTTI_DecapitateHandler;
extern const void * RTTI_FlightTakeOffHandler;
extern const void * RTTI_FlightCruisingHandler;
extern const void * RTTI_FlightHoveringHandler;
extern const void * RTTI_FlightLandingHandler;
extern const void * RTTI_FlightPerchingHandler;
extern const void * RTTI_FlightLandHandler;
extern const void * RTTI_FlightLandEndHandler;
extern const void * RTTI_FlightActionHandler;
extern const void * RTTI_FlightActionEntryEndHandler;
extern const void * RTTI_FlightActionEndHandler;
extern const void * RTTI_FlightActionGrabHandler;
extern const void * RTTI_FlightActionReleaseHandler;
extern const void * RTTI_FlightCrashLandStartHandler;
extern const void * RTTI_HeadTrackingOnHandler;
extern const void * RTTI_HeadTrackingOffHandler;
extern const void * RTTI_BowDrawnHandler;
extern const void * RTTI_BowReleaseHandler;
extern const void * RTTI_ArrowAttachHandler;
extern const void * RTTI_ArrowDetachHandler;
extern const void * RTTI_ArrowReleaseHandler;
extern const void * RTTI_BowZoomStartHandler;
extern const void * RTTI_BowZoomStopHandler;
extern const void * RTTI_InterruptCastHandler;
extern const void * RTTI_EndSummonAnimationHandler;
extern const void * RTTI_PickNewIdleHandler;
extern const void * RTTI_DeathStopHandler;
extern const void * RTTI_ActionActivateDoneHandler;
extern const void * RTTI_StopMountCameraHandler;
extern const void * RTTI_KillMoveStartHandler;
extern const void * RTTI_KillMoveEndHandler;
extern const void * RTTI_PairedStopHandler;
extern const void * RTTI_CameraShakeHandler;
extern const void * RTTI_DeathEmoteHandler;
extern const void * RTTI_MotionDrivenHandler;
extern const void * RTTI_AnimationDrivenHandler;
extern const void * RTTI_AllowRotationHandler;
extern const void * RTTI_AddRagdollHandler;
extern const void * RTTI_RemoveRagdollHandler;
extern const void * RTTI_RagdollStartHandler;
extern const void * RTTI_GetUpStartHandler;
extern const void * RTTI_GetUpEndHandler;
extern const void * RTTI_MountDismountEndHandler;
extern const void * RTTI_ExitCartBeginHandler;
extern const void * RTTI_ExitCartEndHandler;
extern const void * RTTI_EnableCharacterBumperHandler;
extern const void * RTTI_DisableCharacterBumperHandler;
extern const void * RTTI_AnimationObjectLoadHandler;
extern const void * RTTI_AnimationObjectDrawHandler;
extern const void * RTTI_EnableCharacterPitchHandler;
extern const void * RTTI_DisableCharacterPitchHandler;
extern const void * RTTI_JumpAnimEventHandler;
extern const void * RTTI_IdleDialogueEnterHandler;
extern const void * RTTI_IdleDialogueExitHandler;
extern const void * RTTI_AnimatedCameraStartHandler;
extern const void * RTTI_AnimatedCameraDeltaStartHandler;
extern const void * RTTI_AnimatedCameraEndHandler;
extern const void * RTTI_NPCAttachHandler;
extern const void * RTTI_NPCDetachHandler;
extern const void * RTTI_PitchOverrideStartHandler;
extern const void * RTTI_PitchOverrideEndHandler;
extern const void * RTTI_MTStateHandler;
extern const void * RTTI_ZeroPitchHandler;
extern const void * RTTI_VampireFeedEndHandler;
extern const void * RTTI_BGShkMatFadeController;
extern const void * RTTI_BSDirectAtModifierInterface;
extern const void * RTTI_BSPassByTargetTriggerModifierInterface;
extern const void * RTTI_BSRagdollContactListenerModifierInterface;
extern const void * RTTI_ArrowProjectile;
extern const void * RTTI_bhkSPCollisionObject;
extern const void * RTTI_BarrierPhantomCallbackShape;
extern const void * RTTI_BarrierProjectile;
extern const void * RTTI_BeamProjectile;
extern const void * RTTI_ConeProjectile;
extern const void * RTTI_hkpFixedBufferCdPointCollector;
extern const void * RTTI_Explosion;
extern const void * RTTI_FlameProjectile;
extern const void * RTTI_GrenadeProjectile;
extern const void * RTTI_Hazard;
extern const void * RTTI_bhkHingeConstraint;
extern const void * RTTI_MissileProjectile;
extern const void * RTTI_HealthDamageFunctor;
extern const void * RTTI_Projectile;
extern const void * RTTI_CombatAimControllerBase;
extern const void * RTTI_CombatAimController;
extern const void * RTTI_CombatTrackTargetAimController;
extern const void * RTTI_CombatMeleeAimController;
extern const void * RTTI_CombatProjectileAimController;
extern const void * RTTI_CombatDisableAimController;
extern const void * RTTI_CombatArea;
extern const void * RTTI_CombatAreaRadius;
extern const void * RTTI_CombatAreaReference;
extern const void * RTTI_CombatAreaStandard;
extern const void * RTTI_CombatAreaHoldPosition;
extern const void * RTTI_CombatBlackboardKeyBase;
extern const void * RTTI_CombatCoverLocation;
extern const void * RTTI_CombatCoverSearchResult;
extern const void * RTTI_CombatCoverSearch;
extern const void * RTTI_CombatCoverSearchDebugData;
extern const void * RTTI_CombatGroupDetectionListener;
extern const void * RTTI_GatherSpellsFunctor;
extern const void * RTTI_CombatInventoryItem;
extern const void * RTTI_CombatInventoryItemMelee;
extern const void * RTTI_CombatInventoryItemShield;
extern const void * RTTI_CombatInventoryItemOneHandedBlock;
extern const void * RTTI_CombatInventoryItemTorch;
extern const void * RTTI_CombatInventoryItemMagic;
extern const void * RTTI_CombatInventoryItemComposite;
extern const void * RTTI_CombatInventoryItemRanged;
extern const void * RTTI_CombatMagicCaster;
extern const void * RTTI_CombatMagicItemData;
extern const void * RTTI_CombatMagicItemSkillChecker;
extern const void * RTTI_CombatMagicCasterRestore;
extern const void * RTTI_CombatMagicCasterReanimate;
extern const void * RTTI_CombatMagicCasterOffensive;
extern const void * RTTI_CombatMagicCasterWard;
extern const void * RTTI_CombatMagicCasterSummon;
extern const void * RTTI_CombatMagicCasterStagger;
extern const void * RTTI_CombatMagicCasterDisarm;
extern const void * RTTI_CombatMagicCasterCloak;
extern const void * RTTI_CombatMagicCasterLight;
extern const void * RTTI_CombatMagicCasterInvisibility;
extern const void * RTTI_CombatMagicCasterBoundItem;
extern const void * RTTI_CombatMagicCasterArmor;
extern const void * RTTI_CombatMagicCasterTargetEffect;
extern const void * RTTI_CombatMagicCasterParalyze;
extern const void * RTTI_CombatMagicCasterScript;
extern const void * RTTI_CombatTargetLocation;
extern const void * RTTI_CombatTargetLocationSearchResult;
extern const void * RTTI_CombatPath;
extern const void * RTTI_CombatTargetLocationSearch;
extern const void * RTTI_CombatPathingRequest;
extern const void * RTTI_CombatTargetSelector;
extern const void * RTTI_CombatTargetSelectorStandard;
extern const void * RTTI_CombatTargetSelectorFixed;
extern const void * RTTI_CombatThreat;
extern const void * RTTI_hkpClosestCdPointCollector;
extern const void * RTTI_CombatBehaviorResource;
extern const void * RTTI_CombatBehaviorTreeLinkNode;
extern const void * RTTI_CombatBehaviorTreeRootNode;
extern const void * RTTI_CombatBehaviorTreeNode;
extern const void * RTTI_CombatApproachTargetSpeedController;
extern const void * RTTI_CombatFlankingSearchData;
extern const void * RTTI_DiveBombSpeedController;
extern const void * RTTI_CombatDisableActionController;
extern const void * RTTI_CombatSearchLockData;
extern const void * RTTI_IPathBuilder;
extern const void * RTTI_CombatPathBuilder;
extern const void * RTTI_CombatPathBuilderOpen;
extern const void * RTTI_CombatPathBuilderStandard;
extern const void * RTTI_CombatNavmeshSearch;
extern const void * RTTI_CombatPathingDebugData;
extern const void * RTTI_CombatPathingRequestStandard;
extern const void * RTTI_CombatPathingRequestAdapter;
extern const void * RTTI_CombatPathingRequestMultiGoal;
extern const void * RTTI_ThirdPersonState;
extern const void * RTTI_DragonCameraState;
extern const void * RTTI_HorseCameraState;
extern const void * RTTI_FirstPersonState;
extern const void * RTTI_AutoVanityState;
extern const void * RTTI_IronSightsState;
extern const void * RTTI_FurnitureCameraState;
extern const void * RTTI_BleedoutCameraState;
extern const void * RTTI_FreeCameraState;
extern const void * RTTI_PlayerCameraTransitionState;
extern const void * RTTI_PlayerCamera;
extern const void * RTTI_TweenMenuCameraState;
extern const void * RTTI_VATSCameraState;
extern const void * RTTI_FxResponseArgsBase;
extern const void * RTTI_StandardItemData;
extern const void * RTTI_BarterMenu;
extern const void * RTTI_FxResponseArgsList;
extern const void * RTTI_BookMenu;
extern const void * RTTI_IStringForwarder;
extern const void * RTTI_Console;
extern const void * RTTI_ConsoleNativeUIMenu;
extern const void * RTTI_ContainerMenu;
extern const void * RTTI_GRefCountImplCore;
extern const void * RTTI_FxDelegateHandler;
extern const void * RTTI_CraftingMenu;
extern const void * RTTI_MessageBoxData;
extern const void * RTTI_GFxFunctionHandler;
extern const void * RTTI_CreditsMenu;
extern const void * RTTI_MenuEventHandler;
extern const void * RTTI_CursorMenu;
extern const void * RTTI_DialogueMenu;
extern const void * RTTI_FaderMenu;
extern const void * RTTI_FavoritesMenu;
extern const void * RTTI_GiftMenu;
extern const void * RTTI_HUDObject;
extern const void * RTTI_Compass;
extern const void * RTTI_EnemyHealth;
extern const void * RTTI_StealthMeter;
extern const void * RTTI_HUDChargeMeter;
extern const void * RTTI_HUDMeter;
extern const void * RTTI_ActorValueMeter;
extern const void * RTTI_ShoutMeter;
extern const void * RTTI_FloatingQuestMarker;
extern const void * RTTI_HelpMessageManager;
extern const void * RTTI_HUDMenu;
extern const void * RTTI_HUDNotifications;
extern const void * RTTI_Inventory3DManager;
extern const void * RTTI_NewInventoryMenuItemLoadTask;
extern const void * RTTI_InventoryMenu;
extern const void * RTTI_KinectMenu;
extern const void * RTTI_LevelUpMenu;
extern const void * RTTI_LoadingMenu;
extern const void * RTTI_LockpickingMenu;
extern const void * RTTI_MagicItemData;
extern const void * RTTI_MagicMenu;
extern const void * RTTI_MainMenu;
extern const void * RTTI_MenuControls;
extern const void * RTTI_MessageBoxMenu;
extern const void * RTTI_MistMenu;
extern const void * RTTI_RaceSexCamera;
extern const void * RTTI_ThumbstickEvent;
extern const void * RTTI_RaceSexMenu;
extern const void * RTTI_SafeZoneMenu;
extern const void * RTTI_SleepWaitMenu;
extern const void * RTTI_LineNode;
extern const void * RTTI_StatsNode;
extern const void * RTTI_StatsMenu;
extern const void * RTTI_TitleSequenceMenu;
extern const void * RTTI_TrainingMenu;
extern const void * RTTI_TutorialMenu;
extern const void * RTTI_TweenMenu;
extern const void * RTTI_UIBlurManager;
extern const void * RTTI_InventoryUpdateData;
extern const void * RTTI_KinectStateChangeData;
extern const void * RTTI_KinectUserEventData;
extern const void * RTTI_ConsoleData;
extern const void * RTTI_HUDData;
extern const void * RTTI_TransitionState;
extern const void * RTTI_MapCamera;
extern const void * RTTI_MapLookHandler;
extern const void * RTTI_MapZoomHandler;
extern const void * RTTI_MapMoveHandler;
extern const void * RTTI_MapMenu;
extern const void * RTTI_JournalTab;
extern const void * RTTI_Journal_QuestsTab;
extern const void * RTTI_Journal_SystemTab;
extern const void * RTTI_JournalMenu;
extern const void * RTTI_Journal_StatsTab;
extern const void * RTTI_BSCounterStorage;
extern const void * RTTI_SkyrimVM;
extern const void * RTTI_IGiftMenuScriptCallback;
extern const void * RTTI_SkyrimSpeechRecognition;
extern const void * RTTI_BSUIScaleformData;
extern const void * RTTI_GFxState;
extern const void * RTTI_GMemoryFile;
extern const void * RTTI_BSScaleformFileOpener;
extern const void * RTTI_GSysAllocBase;
extern const void * RTTI_BSStreamParserData;
extern const void * RTTI_BSResourceStreamParser;
extern const void * RTTI_GFxZlibSupport;
extern const void * RTTI_GFxLog;
extern const void * RTTI_BSScaleformTranslator;
extern const void * RTTI_IDebugText;
extern const void * RTTI_DebugText;
extern const void * RTTI_RemoveCallbackVisitor;
extern const void * RTTI_AddCallbackVisitor;
extern const void * RTTI_FxDelegate;
extern const void * RTTI_IMenu;
extern const void * RTTI_BSScaleformMovieLoadTask;
extern const void * RTTI_BSScaleformImageLoader;
extern const void * RTTI_MouseMoveEvent;
extern const void * RTTI_CharEvent;
extern const void * RTTI_DeviceConnectEvent;
extern const void * RTTI_KinectEvent;
extern const void * RTTI_BSInputDevice;
extern const void * RTTI_BSGamepadDevice;
extern const void * RTTI_BSWin32MouseDevice;
extern const void * RTTI_BSWin32KeyboardDevice;
extern const void * RTTI_BSWin32GamepadDevice;
extern const void * RTTI_BSMouseDevice;
extern const void * RTTI_BSKeyboardDevice;
extern const void * RTTI_NiControllerManager;
extern const void * RTTI_NiDefaultAVObjectPalette;
extern const void * RTTI_NiMultiTargetTransformController;
extern const void * RTTI_NiTextKeyMatch;
extern const void * RTTI_NiControllerSequence;
extern const void * RTTI_NiBlendInterpolator;
extern const void * RTTI_NiInterpController;
extern const void * RTTI_BSMultiTargetTreadTransfController;
extern const void * RTTI_NiFloatInterpolator;
extern const void * RTTI_NiColorInterpolator;
extern const void * RTTI_NiGeomMorpherController;
extern const void * RTTI_NiPosData;
extern const void * RTTI_NiPathInterpolator;
extern const void * RTTI_NiTransformInterpolator;
extern const void * RTTI_NiSingleInterpController;
extern const void * RTTI_NiBlendTransformInterpolator;
extern const void * RTTI_NiBlendFloatInterpolator;
extern const void * RTTI_NiFloatExtraDataController;
extern const void * RTTI_NiBlendAccumTransformInterpolator;
extern const void * RTTI_NiTransformController;
extern const void * RTTI_NiInterpolator;
extern const void * RTTI_BSBlendTreadTransfInterpolator;
extern const void * RTTI_NiKeyBasedInterpolator;
extern const void * RTTI_NiMorphData;
extern const void * RTTI_NiTransformData;
extern const void * RTTI_NiKFMTool;
extern const void * RTTI_NiActorManager;
extern const void * RTTI_BSFrustumFOVController;
extern const void * RTTI_BSTreadTransfInterpolator;
extern const void * RTTI_BSRotAccumTransfInterpolator;
extern const void * RTTI_BSLookIKNote;
extern const void * RTTI_BSGrabIKNote;
extern const void * RTTI_BSAnimNotes;
extern const void * RTTI_NiVisController;
extern const void * RTTI_NiUVData;
extern const void * RTTI_NiUVController;
extern const void * RTTI_NiTextKeyExtraData;
extern const void * RTTI_NiStringPalette;
extern const void * RTTI_NiSequenceStreamHelper;
extern const void * RTTI_NiSequence;
extern const void * RTTI_NiRotData;
extern const void * RTTI_NiFloatController;
extern const void * RTTI_NiRollController;
extern const void * RTTI_NiQuaternionInterpolator;
extern const void * RTTI_NiPoint3Interpolator;
extern const void * RTTI_NiPathController;
extern const void * RTTI_NiLookAtInterpolator;
extern const void * RTTI_NiLookAtController;
extern const void * RTTI_NiLightDimmerController;
extern const void * RTTI_NiLightColorController;
extern const void * RTTI_NiKeyframeManager;
extern const void * RTTI_NiFloatsExtraDataPoint3Controller;
extern const void * RTTI_NiFloatsExtraDataController;
extern const void * RTTI_NiColorExtraDataController;
extern const void * RTTI_NiBSplineTransformInterpolator;
extern const void * RTTI_NiBSplinePoint3Interpolator;
extern const void * RTTI_NiBSplineFloatInterpolator;
extern const void * RTTI_NiBSplineCompTransformInterpolator;
extern const void * RTTI_NiBSplineCompPoint3Interpolator;
extern const void * RTTI_NiBSplineCompFloatInterpolator;
extern const void * RTTI_NiBSplineCompColorInterpolator;
extern const void * RTTI_NiBSplineColorInterpolator;
extern const void * RTTI_NiBSplineData;
extern const void * RTTI_NiBSplineBasisData;
extern const void * RTTI_NiBoolTimelineInterpolator;
extern const void * RTTI_NiBoolInterpolator;
extern const void * RTTI_NiBoolData;
extern const void * RTTI_NiBoneLODController;
extern const void * RTTI_NiBlendQuaternionInterpolator;
extern const void * RTTI_NiBlendPoint3Interpolator;
extern const void * RTTI_NiBlendColorInterpolator;
extern const void * RTTI_NiBlendBoolInterpolator;
extern const void * RTTI_NiExtraDataController;
extern const void * RTTI_NiFloatInterpController;
extern const void * RTTI_NiBoolInterpController;
extern const void * RTTI_NiPoint3InterpController;
extern const void * RTTI_NiBSplineInterpolator;
extern const void * RTTI_NiNode;
extern const void * RTTI_NiAVObject;
extern const void * RTTI_NiObject;
extern const void * RTTI_NiStream;
extern const void * RTTI_NiObjectNET;
extern const void * RTTI_NiSwitchNode;
extern const void * RTTI_NiStringsExtraData;
extern const void * RTTI_NiRenderer;
extern const void * RTTI_NiCamera;
extern const void * RTTI_NiTriShape;
extern const void * RTTI_NiTriStrips;
extern const void * RTTI_NiLight;
extern const void * RTTI_NiTexture;
extern const void * RTTI_NiSourceTexture;
extern const void * RTTI_NiStringExtraData;
extern const void * RTTI_BSFlattenedBoneTree;
extern const void * RTTI_NiTimeController;
extern const void * RTTI_NiGeometryData;
extern const void * RTTI_NiExtraData;
extern const void * RTTI_NiPointLight;
extern const void * RTTI_NiTriShapeData;
extern const void * RTTI_NiGeometryGroupManager;
extern const void * RTTI_NiLines;
extern const void * RTTI_BSResourceNiBinaryStream;
extern const void * RTTI_NiDirectionalLight;
extern const void * RTTI_NiDevImageConverter;
extern const void * RTTI_NiPixelData;
extern const void * RTTI_NiCullingProcess;
extern const void * RTTI_NiSkinPartition;
extern const void * RTTI_NiSkinData;
extern const void * RTTI_NiTriStripsData;
extern const void * RTTI_BSSegmentedTriShape;
extern const void * RTTI_BSSegmentedLandTriShape;
extern const void * RTTI_NiParticles;
extern const void * RTTI_NiScreenElementsData;
extern const void * RTTI_NiScreenElements;
extern const void * RTTI_NiGeometry;
extern const void * RTTI_NiFloatsExtraData;
extern const void * RTTI_NiColorExtraData;
extern const void * RTTI_NiTriBasedGeom;
extern const void * RTTI_NiVertWeightsExtraData;
extern const void * RTTI_NiImageConverter;
extern const void * RTTI_NiTriBasedGeomData;
extern const void * RTTI_NiLinesData;
extern const void * RTTI_NiPalette;
extern const void * RTTI_NiImageReader;
extern const void * RTTI_NiDDSReader;
extern const void * RTTI_NiTGAReader;
extern const void * RTTI_NiBMPReader;
extern const void * RTTI_NiParticlesData;
extern const void * RTTI_BSLODTriShape;
extern const void * RTTI_NiVectorExtraData;
extern const void * RTTI_NiTriStripsDynamicData;
extern const void * RTTI_NiTriShapeDynamicData;
extern const void * RTTI_NiSwitchStringExtraData;
extern const void * RTTI_NiSpotLight;
extern const void * RTTI_NiSourceCubeMap;
extern const void * RTTI_NiShadeProperty;
extern const void * RTTI_NiPersistentSrcTextureRendererData;
extern const void * RTTI_NiParticleMeshesData;
extern const void * RTTI_NiParticleMeshes;
extern const void * RTTI_NiIntegersExtraData;
extern const void * RTTI_NiIntegerExtraData;
extern const void * RTTI_NiFogProperty;
extern const void * RTTI_NiFloatExtraData;
extern const void * RTTI_NiBSPNode;
extern const void * RTTI_NiBooleanExtraData;
extern const void * RTTI_NiBinaryExtraData;
extern const void * RTTI_NiAmbientLight;
extern const void * RTTI_NiAlphaAccumulator;
extern const void * RTTI_NiNIFImageReader;
extern const void * RTTI_NiBackToFrontAccumulator;
extern const void * RTTI_NiAccumulator;
extern const void * RTTI_QueuedFile;
extern const void * RTTI_QueuedNamedFile;
extern const void * RTTI_BSQueuedResourceCollectionBase;
extern const void * RTTI_IOManager;
extern const void * RTTI_BSTaskThread;
extern const void * RTTI_BSTaskManagerThread;
extern const void * RTTI_BSTaskManager;
extern const void * RTTI_BSMultiBound;
extern const void * RTTI_BSMultiBoundRoom;
extern const void * RTTI_BSXFlags;
extern const void * RTTI_BSReference;
extern const void * RTTI_BSNodeReferences;
extern const void * RTTI_BSValueNode;
extern const void * RTTI_BSTempNode;
extern const void * RTTI_MessageHandler;
extern const void * RTTI_BSRangeNode;
extern const void * RTTI_ITextureDB;
extern const void * RTTI_BSPortalGraph;
extern const void * RTTI_BSPortalGraphEntry;
extern const void * RTTI_BSOcclusionShape;
extern const void * RTTI_BSWindModifier;
extern const void * RTTI_BSBlastNode;
extern const void * RTTI_BSDebrisNode;
extern const void * RTTI_BSDamageStage;
extern const void * RTTI_PArrayPoint;
extern const void * RTTI_BSPSysArrayEmitter;
extern const void * RTTI_BSCullingProcess;
extern const void * RTTI_BSIStream;
extern const void * RTTI_BSOStream;
extern const void * RTTI_BSMultiStreamInstanceTriShape;
extern const void * RTTI_BSMultiBoundShape;
extern const void * RTTI_BSOcclusionPlane;
extern const void * RTTI_BSOcclusionBox;
extern const void * RTTI_BSPortalSharedNode;
extern const void * RTTI_BSBehaviorGraphExtraData;
extern const void * RTTI_BSBodyMorphOffsetsExtraData;
extern const void * RTTI_NiBSBoneLODController;
extern const void * RTTI_BSParticleSystemManager;
extern const void * RTTI_BSFurnitureMarkerNode;
extern const void * RTTI_BSBound;
extern const void * RTTI_BSMultiBoundNode;
extern const void * RTTI_BSAnimInteractionMarker;
extern const void * RTTI_BSBoneMap;
extern const void * RTTI_BSPSysMultiTargetEmitterCtlr;
extern const void * RTTI_BSSceneGraph;
extern const void * RTTI_BSSharedVertexesTriShapeData;
extern const void * RTTI_BSProceduralLightningController;
extern const void * RTTI_BSProceduralLightningTasklet;
extern const void * RTTI_BSInvMarker;
extern const void * RTTI_BSNonUniformScaleExtraData;
extern const void * RTTI_BSLagBoneController;
extern const void * RTTI_BSBoneLODExtraData;
extern const void * RTTI_BSPSysScaleModifier;
extern const void * RTTI_BSPSysSubTexModifier;
extern const void * RTTI_BSPSysStripUpdateModifier;
extern const void * RTTI_BSMultiBoundCapsule;
extern const void * RTTI_BSMasterParticleSystem;
extern const void * RTTI_BSWArray;
extern const void * RTTI_BSParentVelocityModifier;
extern const void * RTTI_BSDecalPlacementVectorExtraData;
extern const void * RTTI_BSNiNode;
extern const void * RTTI_BSInstanceTriShape;
extern const void * RTTI_BSMultiIndexTriShape;
extern const void * RTTI_BSLODMultiIndexTriShape;
extern const void * RTTI_BSTableCurve;
extern const void * RTTI_BSMultiIndexTriShapeData;
extern const void * RTTI_NiFile;
extern const void * RTTI_NiBinaryStream;
extern const void * RTTI_NiAllocator;
extern const void * RTTI_NiStandardAllocator;
extern const void * RTTI_BSNiAllocator;
extern const void * RTTI_NiSearchPath;
extern const void * RTTI_NiThreadProcedure;
extern const void * RTTI_NiMemStream;
extern const void * RTTI_NiThread;
extern const void * RTTI_BSLimbIKModifierCastInfo;
extern const void * RTTI_BSILimbIKModifierSingleton;
extern const void * RTTI_hkbEventPayload;
extern const void * RTTI_hkbStringEventPayload;
extern const void * RTTI_hkbBindable;
extern const void * RTTI_hkbNode;
extern const void * RTTI_BGSGamebryoSequenceGenerator;
extern const void * RTTI_hkbRagdollDriver;
extern const void * RTTI_hkbNodeInternalStateInfo;
extern const void * RTTI_hkbBehaviorGraph;
extern const void * RTTI_hkbVariableValueSet;
extern const void * RTTI_hkbStateListener;
extern const void * RTTI_BSSynchronizedClipGenerator;
extern const void * RTTI_hkbFootIkDriver;
extern const void * RTTI_BSIDirectAtModifierSingleton;
extern const void * RTTI_BSIPassByTargetTriggerModifierSingleton;
extern const void * RTTI_BSIRagdollContactListenerModifierSingleton;
extern const void * RTTI_hkbModifier;
extern const void * RTTI_hkbBoneIndexArray;
extern const void * RTTI_BSRagdollContactListenerModifier;
extern const void * RTTI_hkbHandle;
extern const void * RTTI_hkbStringCondition;
extern const void * RTTI_hkbManualSelectorGeneratorInternalState;
extern const void * RTTI_hkbPoseMatchingGeneratorInternalState;
extern const void * RTTI_hkbCharacterControllerModifierInternalState;
extern const void * RTTI_hkbCombineTransformsModifierInternalState;
extern const void * RTTI_hkbComputeDirectionModifierInternalState;
extern const void * RTTI_hkbComputeRotationFromAxisAngleModifierInternalState;
extern const void * RTTI_hkbComputeRotationToTargetModifierInternalState;
extern const void * RTTI_hkbDampingModifierInternalState;
extern const void * RTTI_hkbDelayedModifierInternalState;
extern const void * RTTI_hkbDetectCloseToGroundModifierInternalState;
extern const void * RTTI_hkbEventDrivenModifierInternalState;
extern const void * RTTI_hkbGetUpModifierInternalState;
extern const void * RTTI_hkbGetWorldFromModelModifierInternalState;
extern const void * RTTI_hkbLookAtModifierInternalState;
extern const void * RTTI_hkbMoveCharacterModifierInternalState;
extern const void * RTTI_hkbRotateCharacterModifierInternalState;
extern const void * RTTI_hkbTimerModifierInternalState;
extern const void * RTTI_hkbTransformVectorModifierInternalState;
extern const void * RTTI_hkbAttachmentSetup;
extern const void * RTTI_hkbRealEventPayload;
extern const void * RTTI_hkbIntEventPayload;
extern const void * RTTI_hkbNamedEventPayload;
extern const void * RTTI_hkbNamedRealEventPayload;
extern const void * RTTI_hkbNamedIntEventPayload;
extern const void * RTTI_hkbNamedStringEventPayload;
extern const void * RTTI_hkbExpressionCondition;
extern const void * RTTI_hkbGeneratorTransitionEffectInternalState;
extern const void * RTTI_hkbMirroredSkeletonInfo;
extern const void * RTTI_hkbCompiledExpressionSet;
extern const void * RTTI_hkbSequenceInternalState;
extern const void * RTTI_hkbEventPayloadList;
extern const void * RTTI_hkbVariableBindingSet;
extern const void * RTTI_hkbTransitionEffect;
extern const void * RTTI_hkbBehaviorGraphData;
extern const void * RTTI_hkbBoneWeightArray;
extern const void * RTTI_hkbFootIkDriverInfo;
extern const void * RTTI_hkbBehaviorReferenceGenerator;
extern const void * RTTI_hkbBlenderGeneratorChild;
extern const void * RTTI_hkbBlenderGenerator;
extern const void * RTTI_hkbBlenderGeneratorInternalState;
extern const void * RTTI_hkbClipGeneratorInternalState;
extern const void * RTTI_hkbRegisteredGenerator;
extern const void * RTTI_hkbManualSelectorGenerator;
extern const void * RTTI_hkbModifierGenerator;
extern const void * RTTI_hkbPoseMatchingGenerator;
extern const void * RTTI_hkbReferencePoseGenerator;
extern const void * RTTI_hkbAttachmentModifier;
extern const void * RTTI_hkbAttributeModifier;
extern const void * RTTI_hkbCharacterControllerModifier;
extern const void * RTTI_hkbCombineTransformsModifier;
extern const void * RTTI_hkbComputeDirectionModifier;
extern const void * RTTI_hkbComputeRotationFromAxisAngleModifier;
extern const void * RTTI_hkbComputeRotationToTargetModifier;
extern const void * RTTI_hkbDampingModifier;
extern const void * RTTI_hkbModifierWrapper;
extern const void * RTTI_hkbDelayedModifier;
extern const void * RTTI_hkbDetectCloseToGroundModifier;
extern const void * RTTI_hkbEvaluateExpressionModifier;
extern const void * RTTI_hkbEvaluateExpressionModifierInternalState;
extern const void * RTTI_hkbEvaluateHandleModifier;
extern const void * RTTI_hkbEventDrivenModifier;
extern const void * RTTI_hkbEventsFromRangeModifier;
extern const void * RTTI_hkbEventsFromRangeModifierInternalState;
extern const void * RTTI_hkbGetHandleOnBoneModifier;
extern const void * RTTI_hkbGetUpModifier;
extern const void * RTTI_hkbGetWorldFromModelModifier;
extern const void * RTTI_hkbHandIkControlsModifier;
extern const void * RTTI_hkbModifierList;
extern const void * RTTI_hkbLookAtModifier;
extern const void * RTTI_hkbMirrorModifier;
extern const void * RTTI_hkbMoveCharacterModifier;
extern const void * RTTI_hkbProxyModifier;
extern const void * RTTI_hkbExtractRagdollPoseModifier;
extern const void * RTTI_hkbKeyframeBonesModifier;
extern const void * RTTI_hkbPoweredRagdollControlsModifier;
extern const void * RTTI_hkbRigidBodyRagdollControlsModifier;
extern const void * RTTI_hkbRotateCharacterModifier;
extern const void * RTTI_hkbSetWorldFromModelModifier;
extern const void * RTTI_hkbTimerModifier;
extern const void * RTTI_hkbTransformVectorModifier;
extern const void * RTTI_hkbTwistModifier;
extern const void * RTTI_hkbSequence;
extern const void * RTTI_hkbEventSequencedData;
extern const void * RTTI_hkbRealVariableSequencedData;
extern const void * RTTI_hkbBoolVariableSequencedData;
extern const void * RTTI_hkbIntVariableSequencedData;
extern const void * RTTI_hkbBlendingTransitionEffect;
extern const void * RTTI_hkbBlendingTransitionEffectInternalState;
extern const void * RTTI_hkbGeneratorTransitionEffect;
extern const void * RTTI_hkbProjectStringData;
extern const void * RTTI_hkbBehaviorGraphStringData;
extern const void * RTTI_hkbCharacterStringData;
extern const void * RTTI_hkbHandIkDriverInfo;
extern const void * RTTI_hkbClipTriggerArray;
extern const void * RTTI_hkbExpressionDataArray;
extern const void * RTTI_hkbEventRangeDataArray;
extern const void * RTTI_hkbFootIkControlsModifier;
extern const void * RTTI_hkbFootIkModifier;
extern const void * RTTI_hkbSenseHandleModifier;
extern const void * RTTI_hkbSequenceStringData;
extern const void * RTTI_hkbStateMachineInternalState;
extern const void * RTTI_hkbHandIkModifier;
extern const void * RTTI_hkbBehaviorGraphInternalState;
extern const void * RTTI_hkbCharacter;
extern const void * RTTI_hkbAnimationBindingSet;
extern const void * RTTI_hkaAnimationBinding;
extern const void * RTTI_hkbAnimationBindingWithTriggers;
extern const void * RTTI_hkbCharacterSetup;
extern const void * RTTI_hkbBindableCollector;
extern const void * RTTI_hkbSymbolIdMap;
extern const void * RTTI_hkbStateMachine;
extern const void * RTTI_hkbClipGenerator;
extern const void * RTTI_BSBoneSwitchGenerator;
extern const void * RTTI_BSBoneSwitchGeneratorBoneData;
extern const void * RTTI_BSCyclicBlendTransitionGenerator;
extern const void * RTTI_BSOffsetAnimationGenerator;
extern const void * RTTI_BSiStateTaggingGenerator;
extern const void * RTTI_BSComputeAddBoneAnimModifier;
extern const void * RTTI_BSDecomposeVectorModifier;
extern const void * RTTI_BSDirectAtModifier;
extern const void * RTTI_BSDistTriggerModifier;
extern const void * RTTI_BSEventEveryNEventsModifier;
extern const void * RTTI_BSEventOnDeactivateModifier;
extern const void * RTTI_BSEventOnFalseToTrueModifier;
extern const void * RTTI_BSGetTimeStepModifier;
extern const void * RTTI_BSInterpValueModifier;
extern const void * RTTI_BSIsActiveModifier;
extern const void * RTTI_BSLimbIKModifier;
extern const void * RTTI_BSLookAtModifier;
extern const void * RTTI_BSModifyOnceModifier;
extern const void * RTTI_BSPassByTargetTriggerModifier;
extern const void * RTTI_BSSpeedSamplerModifier;
extern const void * RTTI_BSTimerModifier;
extern const void * RTTI_BSTweenerModifier;
extern const void * RTTI_BSIStateManagerModifier;
extern const void * RTTI_hkbFootIkSceneModifier;
extern const void * RTTI_hkbHandIkSceneModifier;
extern const void * RTTI_hkbHandIkFixupSceneModifier;
extern const void * RTTI_hkbWorld;
extern const void * RTTI_hkbCharacterData;
extern const void * RTTI_hkbProjectData;
extern const void * RTTI_hkpCharacterControllerCinfo;
extern const void * RTTI_hkpCharacterProxyCinfo;
extern const void * RTTI_hkbHandIkDriver;
extern const void * RTTI_hkbAttachmentFixupSceneModifier;
extern const void * RTTI_hkbRagdollSceneModifier;
extern const void * RTTI_hkbCharacterControllerSceneModifier;
extern const void * RTTI_hkbAttachmentSceneModifier;
extern const void * RTTI_hkbDefaultRaycastInterface;
extern const void * RTTI_hkbClosestLocalFrameCollector;
extern const void * RTTI_NiParticleSystem;
extern const void * RTTI_NiPSysEmitterCtlr;
extern const void * RTTI_NiPSysGravityModifier;
extern const void * RTTI_BSPSysHavokUpdateModifier;
extern const void * RTTI_NiMeshParticleSystem;
extern const void * RTTI_NiPSysCylinderEmitter;
extern const void * RTTI_NiPSysData;
extern const void * RTTI_NiPSysEmitter;
extern const void * RTTI_BSStripParticleSystem;
extern const void * RTTI_NiPSysModifier;
extern const void * RTTI_NiPSysVolumeEmitter;
extern const void * RTTI_NiPSysModifierCtlr;
extern const void * RTTI_BSStripPSysData;
extern const void * RTTI_NiPSysMeshUpdateModifier;
extern const void * RTTI_NiMeshPSysData;
extern const void * RTTI_NiPSysUpdateCtlr;
extern const void * RTTI_NiPSysMeshEmitter;
extern const void * RTTI_BSPSysInheritVelocityModifier;
extern const void * RTTI_BSPSysRecycleBoundModifier;
extern const void * RTTI_NiPSysVortexFieldModifier;
extern const void * RTTI_NiPSysTurbulenceFieldModifier;
extern const void * RTTI_NiPSysSphericalCollider;
extern const void * RTTI_NiPSysSphereEmitter;
extern const void * RTTI_NiPSysSpawnModifier;
extern const void * RTTI_NiPSysRotationModifier;
extern const void * RTTI_NiPSysResetOnLoopCtlr;
extern const void * RTTI_NiPSysRadialFieldModifier;
extern const void * RTTI_NiPSysPositionModifier;
extern const void * RTTI_NiPSysPlanarCollider;
extern const void * RTTI_NiPSysModifierActiveCtlr;
extern const void * RTTI_NiPSysInitialRotSpeedVarCtlr;
extern const void * RTTI_NiPSysInitialRotSpeedCtlr;
extern const void * RTTI_NiPSysInitialRotAngleVarCtlr;
extern const void * RTTI_NiPSysInitialRotAngleCtlr;
extern const void * RTTI_NiPSysGrowFadeModifier;
extern const void * RTTI_NiPSysGravityStrengthCtlr;
extern const void * RTTI_NiPSysGravityFieldModifier;
extern const void * RTTI_NiPSysFieldMaxDistanceCtlr;
extern const void * RTTI_NiPSysFieldMagnitudeCtlr;
extern const void * RTTI_NiPSysFieldAttenuationCtlr;
extern const void * RTTI_NiPSysEmitterSpeedCtlr;
extern const void * RTTI_NiPSysEmitterPlanarAngleVarCtlr;
extern const void * RTTI_NiPSysEmitterPlanarAngleCtlr;
extern const void * RTTI_NiPSysEmitterLifeSpanCtlr;
extern const void * RTTI_NiPSysEmitterInitialRadiusCtlr;
extern const void * RTTI_NiPSysEmitterDeclinationVarCtlr;
extern const void * RTTI_NiPSysEmitterDeclinationCtlr;
extern const void * RTTI_NiPSysEmitterCtlrData;
extern const void * RTTI_NiPSysDragModifier;
extern const void * RTTI_NiPSysDragFieldModifier;
extern const void * RTTI_NiPSysColorModifier;
extern const void * RTTI_NiPSysColliderManager;
extern const void * RTTI_NiPSysBoxEmitter;
extern const void * RTTI_NiPSysBoundUpdateModifier;
extern const void * RTTI_NiPSysBombModifier;
extern const void * RTTI_NiPSysAgeDeathModifier;
extern const void * RTTI_NiPSysAirFieldSpreadCtlr;
extern const void * RTTI_NiPSysAirFieldModifier;
extern const void * RTTI_NiPSysAirFieldInheritVelocityCtlr;
extern const void * RTTI_NiPSysAirFieldAirFrictionCtlr;
extern const void * RTTI_NiPSysFieldModifier;
extern const void * RTTI_NiPSysCollider;
extern const void * RTTI_NiPSysModifierBoolCtlr;
extern const void * RTTI_NiPSysModifierFloatCtlr;
extern const void * RTTI_hkReferencedObjectLock;
extern const void * RTTI_hkpKeyframedRigidMotion;
extern const void * RTTI_hkpMaxSizeMotion;
extern const void * RTTI_hkpMotion;
extern const void * RTTI_hkpFixedRigidMotion;
extern const void * RTTI_hkpSphereMotion;
extern const void * RTTI_hkpBoxMotion;
extern const void * RTTI_hkpThinBoxMotion;
extern const void * RTTI_hkpCharacterMotion;
extern const void * RTTI_hkpWorldObject;
extern const void * RTTI_hkpEntity;
extern const void * RTTI_hkMemoryAllocator;
extern const void * RTTI_hkLifoAllocator;
extern const void * RTTI_hkpRigidBody;
extern const void * RTTI_hkpShapeContainer;
extern const void * RTTI_hkpSingleShapeContainer;
extern const void * RTTI_hkpBvShape;
extern const void * RTTI_hkpBoxShape;
extern const void * RTTI_hkpConvexTransformShapeBase;
extern const void * RTTI_hkpAabbPhantom;
extern const void * RTTI_hkpPhantom;
extern const void * RTTI_hkpCharacterContext;
extern const void * RTTI_hkpPrismaticConstraintData;
extern const void * RTTI_hkpAction;
extern const void * RTTI_hkpUnaryAction;
extern const void * RTTI_hkpCollidableCollidableFilter;
extern const void * RTTI_hkpRayCollidableFilter;
extern const void * RTTI_hkpShapeCollectionFilter;
extern const void * RTTI_hkpRayShapeCollectionFilter;
extern const void * RTTI_hkpConstraintListener;
extern const void * RTTI_hkpDefaultWorldMemoryWatchDog;
extern const void * RTTI_hkpCollisionFilter;
extern const void * RTTI_hkpConstraintChainInstanceAction;
extern const void * RTTI_hkpConstraintMotor;
extern const void * RTTI_hkpLimitedForceConstraintMotor;
extern const void * RTTI_hkpCallbackConstraintMotor;
extern const void * RTTI_hkpPositionConstraintMotor;
extern const void * RTTI_hkpSpringDamperConstraintMotor;
extern const void * RTTI_hkpVelocityConstraintMotor;
extern const void * RTTI_hkpSimulation;
extern const void * RTTI_hkpPairCollisionFilter;
extern const void * RTTI_hkpConstraintCollisionFilter;
extern const void * RTTI_hkpBallAndSocketConstraintData;
extern const void * RTTI_hkpCogWheelConstraintData;
extern const void * RTTI_hkpHingeConstraintData;
extern const void * RTTI_hkpLimitedHingeConstraintData;
extern const void * RTTI_hkpPointToPathConstraintData;
extern const void * RTTI_hkpPointToPlaneConstraintData;
extern const void * RTTI_hkpRackAndPinionConstraintData;
extern const void * RTTI_hkpRagdollConstraintData;
extern const void * RTTI_hkpStiffSpringConstraintData;
extern const void * RTTI_hkpWheelConstraintData;
extern const void * RTTI_hkpRotationalConstraintData;
extern const void * RTTI_hkpHingeLimitsData;
extern const void * RTTI_hkpRagdollLimitsData;
extern const void * RTTI_hkpPulleyConstraintData;
extern const void * RTTI_hkpConstraintInstance;
extern const void * RTTI_hkpLinearParametricCurve;
extern const void * RTTI_hkpConstraintChainInstance;
extern const void * RTTI_hkpShapePhantom;
extern const void * RTTI_hkpCachingShapePhantom;
extern const void * RTTI_hkpSimpleShapePhantom;
extern const void * RTTI_hkpPhysicsSystem;
extern const void * RTTI_hkpNullContactMgr;
extern const void * RTTI_hkpBroadPhaseListener;
extern const void * RTTI_hkpDefaultConvexListFilter;
extern const void * RTTI_hkpBroadPhaseCastCollector;
extern const void * RTTI_hkpWorldRayCaster;
extern const void * RTTI_hkpPhantomBroadPhaseListener;
extern const void * RTTI_hkpBroadPhaseBorderListener;
extern const void * RTTI_hkpNullContactMgrFactory;
extern const void * RTTI_hkpNullCollisionFilter;
extern const void * RTTI_hkpSimpleWorldRayCaster;
extern const void * RTTI_hkpWorldLinearCaster;
extern const void * RTTI_hkpWorld;
extern const void * RTTI_hkpCollisionCallbackUtil;
extern const void * RTTI_hkErrStream;
extern const void * RTTI_hkpPlaneShape;
extern const void * RTTI_hkaFootPlacementIkSolver;
extern const void * RTTI_hkpSphereShape;
extern const void * RTTI_hkpCharacterRigidBody;
extern const void * RTTI_hkpCharacterStateManager;
extern const void * RTTI_hkpMouseSpringAction;
extern const void * RTTI_hkLoader;
extern const void * RTTI_hkDefaultBuiltinTypeRegistry;
extern const void * RTTI_hkTypeInfoRegistry;
extern const void * RTTI_hkDynamicClassNameRegistry;
extern const void * RTTI_hkDefaultClassNameRegistry;
extern const void * RTTI_hkVtableClassRegistry;
extern const void * RTTI_hkBufferedStreamReader;
extern const void * RTTI_hkCrc32StreamWriter;
extern const void * RTTI_hkaRagdollInstance;
extern const void * RTTI_hkpEaseConstraintsAction;
extern const void * RTTI_hkpEasePenetrationAction;
extern const void * RTTI_hkaSkeletonMapper;
extern const void * RTTI_hkaBoneAttachment;
extern const void * RTTI_hkaAnimationPreviewColorContainer;
extern const void * RTTI_hkaDefaultAnimatedReferenceFrame;
extern const void * RTTI_hkaSkeleton;
extern const void * RTTI_hkaFootstepAnalysisInfoContainer;
extern const void * RTTI_hkaAnimationContainer;
extern const void * RTTI_hkaAnimation;
extern const void * RTTI_hkaInterleavedUncompressedAnimation;
extern const void * RTTI_hkaQuantizedAnimation;
extern const void * RTTI_hkaSplineCompressedAnimation;
extern const void * RTTI_hkaDefaultAnimationControl;
extern const void * RTTI_hkaDefaultAnimationControlMapperData;
extern const void * RTTI_hkStatisticsCollector;
extern const void * RTTI_hkLocalFrameGroup;
extern const void * RTTI_hkSimpleLocalFrame;
extern const void * RTTI_hkaAnimationControl;
extern const void * RTTI_hkpBinaryAction;
extern const void * RTTI_hkpAngularDashpotAction;
extern const void * RTTI_hkpDashpotAction;
extern const void * RTTI_hkpMotorAction;
extern const void * RTTI_hkpReorientAction;
extern const void * RTTI_hkpSpringAction;
extern const void * RTTI_hkpConstrainedSystemFilter;
extern const void * RTTI_hkpGroupCollisionFilter;
extern const void * RTTI_hkpSerializedDisplayMarker;
extern const void * RTTI_hkpPhysicsData;
extern const void * RTTI_hkpPoweredChainMapper;
extern const void * RTTI_hkpDisableEntityCollisionFilter;
extern const void * RTTI_hkpPhysicsSystemWithContacts;
extern const void * RTTI_hkpSerializedDisplayMarkerList;
extern const void * RTTI_hkpSerializedDisplayRbTransforms;
extern const void * RTTI_hkaMirroredSkeleton;
extern const void * RTTI_hkpCharacterProxy;
extern const void * RTTI_hkpConstraintOwner;
extern const void * RTTI_hkpCapsuleShape;
extern const void * RTTI_hkpGroupFilter;
extern const void * RTTI_hkOstream;
extern const void * RTTI_hkMemoryTrackStreamWriter;
extern const void * RTTI_hkArrayStreamWriter;
extern const void * RTTI_hkpSymmetricAgentFlipCollector;
extern const void * RTTI_hkpSymmetricAgentFlipCastCollector;
extern const void * RTTI_hkpSymmetricAgentFlipBodyCollector;
extern const void * RTTI_hkpFlagCdBodyPairCollector;
extern const void * RTTI_hkpSimpleClosestContactCollector;
extern const void * RTTI_hkpBvAgent;
extern const void * RTTI_hkpWorldDeletionListener;
extern const void * RTTI_hkpSuspendInactiveAgentsUtil;
extern const void * RTTI_hkDummySingleton;
extern const void * RTTI_hkMemorySystem;
extern const void * RTTI_hkThreadMemory;
extern const void * RTTI_hkFreeListMemorySystem;
extern const void * RTTI_hkpConvexTranslateShape;
extern const void * RTTI_hkpMalleableConstraintData;
extern const void * RTTI_hkpShapeCollection;
extern const void * RTTI_hkpListShape;
extern const void * RTTI_hkaDetectRagdollPenetration;
extern const void * RTTI_hkpMoppModifier;
extern const void * RTTI_hkMoppBvTreeShapeBase;
extern const void * RTTI_hkpBvTreeShape;
extern const void * RTTI_hkpMoppBvTreeShape;
extern const void * RTTI_hkpConvexTransformShape;
extern const void * RTTI_hkpTriangleShape;
extern const void * RTTI_hkpMultiSphereShape;
extern const void * RTTI_hkpTransformShape;
extern const void * RTTI_hkpCollisionFilterList;
extern const void * RTTI_hkpRemoveTerminalsMoppModifier;
extern const void * RTTI_hkpConvexVerticesConnectivity;
extern const void * RTTI_hkpConvexListShape;
extern const void * RTTI_hkpMultiRayShape;
extern const void * RTTI_hkpShapeInfo;
extern const void * RTTI_hkXmlTagfileReader;
extern const void * RTTI_hkXmlTagfileWriter;
extern const void * RTTI_hkBinaryTagfileWriter;
extern const void * RTTI_hkpSampledHeightFieldShape;
extern const void * RTTI_hkpTriSampledHeightFieldBvTreeShape;
extern const void * RTTI_hkpCompressedSampledHeightFieldShape;
extern const void * RTTI_hkpStorageSampledHeightFieldShape;
extern const void * RTTI_hkpTriSampledHeightFieldCollection;
extern const void * RTTI_hkpStorageExtendedMeshShape;
extern const void * RTTI_hkpStorageMeshShape;
extern const void * RTTI_hkpFastMeshShape;
extern const void * RTTI_hkpBreakableConstraintData;
extern const void * RTTI_hkpBallSocketChainData;
extern const void * RTTI_hkpStiffSpringChainData;
extern const void * RTTI_hkpGenericConstraintData;
extern const void * RTTI_hkpNullBroadPhaseListener;
extern const void * RTTI_hkpCollisionDispatcher;
extern const void * RTTI_hkpReportContactMgr;
extern const void * RTTI_hkpSimpleContactConstraintData;
extern const void * RTTI_hkpSimpleConstraintContactMgr;
extern const void * RTTI_hkpSimulationIsland;
extern const void * RTTI_hkpEndOfStepCallbackUtil;
extern const void * RTTI_hkpWorldExtension;
extern const void * RTTI_hkpDefaultWorldMaintenanceMgr;
extern const void * RTTI_hkpPhantomOverlapListener;
extern const void * RTTI_hkpBroadPhaseBorder;
extern const void * RTTI_hkpNullAgent;
extern const void * RTTI_hkpEntityEntityBroadPhaseListener;
extern const void * RTTI_hkp3AxisSweep;
extern const void * RTTI_hkBufferedStreamWriter;
extern const void * RTTI_hkStdioStreamWriter;
extern const void * RTTI_hkStdioStreamReader;
extern const void * RTTI_hkIstream;
extern const void * RTTI_hkStaticClassNameRegistry;
extern const void * RTTI_hkOArchive;
extern const void * RTTI_hkResourceMap;
extern const void * RTTI_hkContainerResourceMap;
extern const void * RTTI_hkMemoryResourceHandle;
extern const void * RTTI_hkMemoryResourceContainer;
extern const void * RTTI_hkpArrayAction;
extern const void * RTTI_hkxCamera;
extern const void * RTTI_hkxTextureFile;
extern const void * RTTI_hkxLight;
extern const void * RTTI_hkxAnimatedFloat;
extern const void * RTTI_hkxAnimatedMatrix;
extern const void * RTTI_hkxAnimatedQuaternion;
extern const void * RTTI_hkxAnimatedVector;
extern const void * RTTI_hkxSparselyAnimatedBool;
extern const void * RTTI_hkxSparselyAnimatedInt;
extern const void * RTTI_hkxSparselyAnimatedEnum;
extern const void * RTTI_hkxMaterialEffect;
extern const void * RTTI_hkxMaterialShader;
extern const void * RTTI_hkxTextureInplace;
extern const void * RTTI_hkxEdgeSelectionChannel;
extern const void * RTTI_hkxTriangleSelectionChannel;
extern const void * RTTI_hkxVertexFloatDataChannel;
extern const void * RTTI_hkxVertexIntDataChannel;
extern const void * RTTI_hkxVertexSelectionChannel;
extern const void * RTTI_hkxVertexVectorDataChannel;
extern const void * RTTI_hkxIndexBuffer;
extern const void * RTTI_hkxEnum;
extern const void * RTTI_hkxSparselyAnimatedString;
extern const void * RTTI_hkxSkinBinding;
extern const void * RTTI_hkxMeshSection;
extern const void * RTTI_hkxScene;
extern const void * RTTI_hkxAttributeHolder;
extern const void * RTTI_hkxNode;
extern const void * RTTI_hkxMaterial;
extern const void * RTTI_hkxNodeSelectionSet;
extern const void * RTTI_hkaMeshBinding;
extern const void * RTTI_hkaFootstepAnalysisInfo;
extern const void * RTTI_hkObjectCopier;
extern const void * RTTI_hkTrackerSerializableScanSnapshot;
extern const void * RTTI_hkTrackerTypeTreeTextCache;
extern const void * RTTI_hkpTriggerVolume;
extern const void * RTTI_hkpBallGun;
extern const void * RTTI_hkpFirstPersonGun;
extern const void * RTTI_hkpGravityGun;
extern const void * RTTI_hkpMountedBallGun;
extern const void * RTTI_hkpGunProjectile;
extern const void * RTTI_hkpProjectileGun;
extern const void * RTTI_hkMemoryTrackStreamReader;
extern const void * RTTI_hkStackTracer;
extern const void * RTTI_hkCpuJobThreadPool;
extern const void * RTTI_hkpBvTreeStreamAgent;
extern const void * RTTI_hkpBvTreeAgent;
extern const void * RTTI_hkpMoppAgent;
extern const void * RTTI_hkpMapPointsToSubShapeContactMgr;
extern const void * RTTI_hkpPredGskfAgent;
extern const void * RTTI_hkpConvexListAgent;
extern const void * RTTI_hkpListAgent;
extern const void * RTTI_hkpMultiRayConvexAgent;
extern const void * RTTI_hkpMultiSphereTriangleAgent;
extern const void * RTTI_hkpCapsuleTriangleAgent;
extern const void * RTTI_hkpCapsuleCapsuleAgent;
extern const void * RTTI_hkpSphereBoxAgent;
extern const void * RTTI_hkpSphereTriangleAgent;
extern const void * RTTI_hkpSphereCapsuleAgent;
extern const void * RTTI_hkpSphereSphereAgent;
extern const void * RTTI_hkpBoxBoxAgent;
extern const void * RTTI_hkpPhantomAgent;
extern const void * RTTI_hkpTransformAgent;
extern const void * RTTI_hkpShapeCollectionAgent;
extern const void * RTTI_hkpMultiSphereAgent;
extern const void * RTTI_hkpCylinderShape;
extern const void * RTTI_hkpConvexVerticesShape;
extern const void * RTTI_hkpCompressedMeshShape;
extern const void * RTTI_hkDefaultError;
extern const void * RTTI_hkSocket;
extern const void * RTTI_hkSolverAllocator;
extern const void * RTTI_hkStatsAllocator;
extern const void * RTTI_hkgpConvexHull;
extern const void * RTTI_hkpConvexPieceStreamData;
extern const void * RTTI_hkpRemoveTerminalsMoppModifier2;
extern const void * RTTI_hkpBroadPhase;
extern const void * RTTI_hkVersionPatchManager;
extern const void * RTTI_hkSerializeDeprecated;
extern const void * RTTI_hkDataRefCounted;
extern const void * RTTI_hkDataClassNative;
extern const void * RTTI_hkDataObjectNative;
extern const void * RTTI_hkDataArrayNative;
extern const void * RTTI_hkDataWorldNative;
extern const void * RTTI_hkBinaryPackfileWriter;
extern const void * RTTI_hkSubStreamWriter;
extern const void * RTTI_hkTempDetectAllocator;
extern const void * RTTI_hkPackfileWriter;
extern const void * RTTI_hkBinaryTagfileReader;
extern const void * RTTI_hkPooledAllocator;
extern const void * RTTI_hkDataObjectDict;
extern const void * RTTI_hkDataClassDict;
extern const void * RTTI_hkDataWorldDict;
extern const void * RTTI_hkpExtendedMeshShape;
extern const void * RTTI_hkpMeshShape;
extern const void * RTTI_hkTraceStream;
extern const void * RTTI_hkMemoryStreamReader;
extern const void * RTTI_hkpMultiThreadedSimulation;
extern const void * RTTI_hkpContinuousSimulation;
extern const void * RTTI_hkHeightFieldRayForwardingCollector;
extern const void * RTTI_hkpHeightFieldAgent;
extern const void * RTTI_hkAlignSceneToNodeOptions;
extern const void * RTTI_hkxEnvironment;
extern const void * RTTI_hkxMaterialShaderSet;
extern const void * RTTI_hkxMesh;
extern const void * RTTI_hkxVertexBuffer;
extern const void * RTTI_hkTrackerScanSnapshot;
extern const void * RTTI_hkpPoweredChainData;
extern const void * RTTI_hkpGskBaseAgent;
extern const void * RTTI_hkpGskfAgent;
extern const void * RTTI_hkpMoppCostFunction;
extern const void * RTTI_hkpMoppShapeMediator;
extern const void * RTTI_hkpMoppCachedShapeMediator;
extern const void * RTTI_hkgpIndexedMesh;
extern const void * RTTI_hkBsdSocket;
extern const void * RTTI_hkParserBuffer;
extern const void * RTTI_hkXmlStreamParser;
extern const void * RTTI_hkPlatformObjectWriter;
extern const void * RTTI_hkOffsetOnlyStreamWriter;
extern const void * RTTI_hkObjectResource;
extern const void * RTTI_hkPackfileData;
extern const void * RTTI_hkIArchive;
extern const void * RTTI_hkpDeferredConstraintOwner;
extern const void * RTTI_hkpDefaultToiResourceMgr;
extern const void * RTTI_hkTrackerTypeTreeCache;
extern const void * RTTI_hkKdTreeCastCollector;
extern const void * RTTI_hkCpuWorldGetClosestPointsCollector;
extern const void * RTTI_hkCpuWorldLinearCastCollector;
extern const void * RTTI_hkCpuWorldRayCastCollector;
extern const void * RTTI_hkpFixedBufferRayHitCollector;
extern const void * RTTI_hkpMoppCodeGenerator;
extern const void * RTTI_hkpMoppDefaultAssembler;
extern const void * RTTI_hkpMoppDefaultSplitter;
extern const void * RTTI_hkpSimpleMeshShape;
extern const void * RTTI_hkgpMesh;
extern const void * RTTI_hkXmlLexAnalyzer;
extern const void * RTTI_hkMemoryTracker;
extern const void * RTTI_hkDummyMemoryTrackerImpl;
extern const void * RTTI_hkDefaultMemoryTracker;
extern const void * RTTI_hkKdTreeBundleCastCollector;
extern const void * RTTI_hkpCollidableMediator;
extern const void * RTTI_hkTrackerArrayLayoutHandler;
extern const void * RTTI_hkTrackerRefPtrLayoutHandler;
extern const void * RTTI_hkTrackerStringPtrLayoutHandler;
extern const void * RTTI_hkTrackerCachedHashMapLayoutHandler;
extern const void * RTTI_hkTrackerStringMapLayoutHandler;
extern const void * RTTI_hkTrackerLayoutCalculator;
extern const void * RTTI_hkTrackerTypeLayout;
extern const void * RTTI_hkKdTreeCpuBroadphaseBundleCastCollector;
extern const void * RTTI_NiCollisionData;
extern const void * RTTI_NiOBBRoot;
extern const void * RTTI_NiOBBNode;
extern const void * RTTI_NiOBBLeaf;
extern const void * RTTI_MoviePlayer;
extern const void * RTTI_type_info;
extern const void * RTTI_NiDepthStencilBuffer;
extern const void * RTTI_NiRenderedTexture;
extern const void * RTTI_NiRenderedCubeMap;
extern const void * RTTI_NiRenderTargetGroup;
extern const void * RTTI_NiShaderDeclaration;
extern const void * RTTI_Ni2DBuffer;
extern const void * RTTI_NiCollisionObject;
extern const void * RTTI_BSShapeConstructor;
extern const void * RTTI_BSSphereConstructor;
extern const void * RTTI_BSCylinderConstructor;
extern const void * RTTI_BSCapsuleConstructor;
extern const void * RTTI_BSCircleConstructor;
extern const void * RTTI_BSRingConstructor;
extern const void * RTTI_BSFlatQuadConstructor;
extern const void * RTTI_BSDiskConstructor;
extern const void * RTTI_BSBoxConstructor;
extern const void * RTTI_BSOrientedBoxConstructor;
extern const void * RTTI_BSArrowConstructor;
extern const void * RTTI_BSTextureData;
extern const void * RTTI_BSParabolicCullingProcess;
extern const void * RTTI_hkbTestStateChooser;
extern const void * RTTI_hkbRaiseEventCommand;
extern const void * RTTI_hkbSetLocalTimeOfClipGeneratorCommand;
extern const void * RTTI_hkbSetNodePropertyCommand;
extern const void * RTTI_hkbEventRaisedInfo;
extern const void * RTTI_hkbCameraShakeEventPayload;
extern const void * RTTI_hkbParticleSystemEventPayload;
extern const void * RTTI_hkbSimulationControlCommand;
extern const void * RTTI_hkbCharacterControlCommand;
extern const void * RTTI_hkbSetWordVariableCommand;
extern const void * RTTI_hkbCharacterInfo;
extern const void * RTTI_hkbSimulationStateInfo;
extern const void * RTTI_hkbBehaviorEventsInfo;
extern const void * RTTI_hkbCharacterAddedInfo;
extern const void * RTTI_hkbCharacterSteppedInfo;
extern const void * RTTI_hkbCharacterSkinInfo;
extern const void * RTTI_hkbBehaviorInfo;
extern const void * RTTI_hkbLinkedSymbolInfo;
extern const void * RTTI_hkbAuxiliaryNodeInfo;
extern const void * RTTI_hkbSetBehaviorCommand;
extern const void * RTTI_hkbBehaviorGraphInternalStateInfo;
extern const void * RTTI_hkRemoteObjectClientSideListener;
extern const void * RTTI_hkbClientCharacterState;
extern const void * RTTI_hkbBehaviorClient;
extern const void * RTTI_hkProcess;
extern const void * RTTI_hkRemoteObjectProcess;
extern const void * RTTI_hkProcessFactory;
extern const void * RTTI_BSMusicManager;
